SystemOrganization addCategory: #'RPackage-Core'!

!PackageInfo methodsFor: '*RPackage-Core' stamp: 'cyrille.delaunay 11/25/2010 16:40'!
classesAndMetaClassesNotDefinedInSubCategories

	|subCategoriesClasses|
	subCategoriesClasses := OrderedCollection new.
	self systemCategories do: [:aSymbol |
		aSymbol = self packageName asSymbol
			ifFalse: [
				subCategoriesClasses addAll: (PackageOrganizer default packageNamed: aSymbol ifAbsent: [PackageInfo new]) classesAndMetaClasses
				]
		].
	^ self classesAndMetaClasses difference: subCategoriesClasses! !

!PackageInfo methodsFor: '*RPackage-Core' stamp: 'cyrilledelaunay 2/9/2011 10:53'!
classesNotDefinedInSubCategories

	"return all classes that are defined in a category matching exactly the name of this package. Rpackage has to re-order each class in its right package. See RPackageOrganizer>>importFromPackageInfo:"
	|subCategoriesClasses|
	subCategoriesClasses := OrderedCollection new.
	self systemCategories do: [:aSymbol |
		aSymbol = self packageName asSymbol
			ifFalse: [
				subCategoriesClasses addAll: (PackageInfo named: aSymbol asString) classes
				]
		].
	^ self classes difference: subCategoriesClasses! !

!PackageInfo methodsFor: '*RPackage-Core' stamp: 'cyrille.delaunay 10/29/2010 10:31'!
coreMethodsNotDefinedInSubCategories

	^ self classesAndMetaClassesNotDefinedInSubCategories gather: [:class | self coreMethodsForClass: class]! !

!PackageInfo methodsFor: '*RPackage-Core' stamp: 'EstebanLorenzano 8/3/2012 11:08'!
extensionMethodsFromAllSystem
	^ Smalltalk allClassesAndTraits gather: [:classOrTrait | self extensionMethodsForClass: classOrTrait]! !

!PackageInfo methodsFor: '*RPackage-Core' stamp: 'cyrille.delaunay 10/29/2010 10:37'!
extensionMethodsNotDefinedInSubCategories
	^ self externalBehaviorsNotDefinedInSubCategories gather: [:classOrTrait | self extensionMethodsForClass: classOrTrait]! !

!PackageInfo methodsFor: '*RPackage-Core' stamp: 'cyrille.delaunay 10/29/2010 10:37'!
externalBehaviorsNotDefinedInSubCategories
	^self externalClassesNotDefinedInSubCategories , self externalTraitsNotDefinedInSubCategories! !

!PackageInfo methodsFor: '*RPackage-Core' stamp: 'cyrille.delaunay 10/29/2010 10:33'!
externalClassesNotDefinedInSubCategories
	| myClasses |
	myClasses := self classesAndMetaClassesNotDefinedInSubCategories.
	^ Array streamContents:
		[:s |
		ProtoObject withAllSubclassesDo:
			[:class |
			(myClasses includes: class) ifFalse: [s nextPut: class]]]! !

!PackageInfo methodsFor: '*RPackage-Core' stamp: 'cyrille.delaunay 10/29/2010 10:35'!
externalTraitsNotDefinedInSubCategories
	
	
	^ Array streamContents: [:s | | behaviors |
		behaviors := self classesAndMetaClassesNotDefinedInSubCategories.
		Smalltalk allTraits do: [:trait |
			(behaviors includes: trait) ifFalse: [s nextPut: trait].
			(behaviors includes: trait classSide) ifFalse: [s nextPut: trait classSide]]].			! !

Announcement subclass: #RPackageAnnouncement
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Core'!

!RPackageAnnouncement class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 4/1/2011 16:14'!
to: aPackage

	^ self new package: aPackage! !

!RPackageAnnouncement methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/1/2011 16:14'!
package

	^ package! !

!RPackageAnnouncement methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/1/2011 16:14'!
package: anObject

	package := anObject! !

RPackageAnnouncement subclass: #RPackageCreated
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Core'!

!RPackageCreated commentStamp: '<historical>' prior: 0!
I am a public announcement sent when a new RPackage is created!

RPackageAnnouncement subclass: #RPackageRenamed
	instanceVariableNames: 'oldName newName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Core'!

!RPackageRenamed commentStamp: '<historical>' prior: 0!
I am a public announcement sent when a new RPackage is renamed!

!RPackageRenamed class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 4/1/2011 16:24'!
to: aPackage oldName: aSymbol newName: anotherSymbol

	^ (super to: aPackage) 
		oldName: aSymbol;
		newName: anotherSymbol;
		yourself! !

!RPackageRenamed methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/1/2011 16:22'!
newName

	^ newName! !

!RPackageRenamed methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/1/2011 16:22'!
newName: anObject

	newName := anObject! !

!RPackageRenamed methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/1/2011 16:22'!
oldName

	^ oldName! !

!RPackageRenamed methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/1/2011 16:22'!
oldName: anObject

	oldName := anObject! !

RPackageAnnouncement subclass: #RPackageUnregistered
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Core'!

!RPackageUnregistered commentStamp: '<historical>' prior: 0!
I am a public announcement sent when a new RPackage is unregistred ( kind  of removed from the system )!

!TPureBehavior methodsFor: '*Rpackage-Core' stamp: 'GuillermoPolito 5/29/2012 13:09'!
originalName
	^self isObsolete 
		ifTrue: [ (self name copyFrom:   'AnObsolete' size + 1 to: self name size ) asSymbol ]
		ifFalse:  [  self name asSymbol ].! !

!CompiledMethod methodsFor: '*rpackage-core' stamp: 'EstebanLorenzano 6/1/2012 16:48'!
handleUnpackaged: anRPackageOrganizer
	| tmpTrait |
	tmpTrait := self methodClass traitComposition traitProvidingSelector: self selector.
	
	tmpTrait isNil ifFalse: [
		(tmpTrait packages select: [ :aRPackage | 
			aRPackage includesSelector: self selector ofClass: tmpTrait ]) isEmpty 
				ifFalse: [ ^ self ]].
 
	self error: 'Yes... method is unpackaged and I don''t know what to do with this.'.
"	self halt.
	self category isNil
		ifTrue: [ Error signal ].
		
	anRPackageOrganizer
		systemMethodAddedActionFrom:
			(AddedEvent
				method: self
				selector: self selector
				protocol: self category
				class: self methodClass) asSystemAnnouncement"! !

!CompiledMethod methodsFor: '*rpackage-core' stamp: 'tg 3/13/2010 15:13'!
isDefinedInPackage: anRPackage
	^ anRPackage includesDefinedSelector: self selector ofClass: self methodClass! !

!CompiledMethod methodsFor: '*rpackage-core' stamp: 'tg 3/13/2010 13:50'!
isExtensionInPackage: anRPackage
	^ anRPackage includesExtensionSelector: self selector ofClass: self methodClass! !

!CompiledMethod methodsFor: '*rpackage-core' stamp: 'CamilloBruni 4/27/2012 17:43'!
isProvidedByATrait

	^ self origin isTrait
	! !

!CompiledMethod methodsFor: '*rpackage-core' stamp: 'CamilloBruni 4/27/2012 17:07'!
package
	^ self packageFromOrganizer: RPackage organizer! !

!CompiledMethod methodsFor: '*rpackage-core' stamp: 'GuillermoPolito 6/3/2012 01:15'!
packageFromOrganizer: anRPackageOrganizer
	"This method returns the package this method belongs to.  It takes into account classes and traits.  If the method is in no package, returns nil by now"
	^self origin packages detect: [:each | each includesSelector: self selector ofClassName: self origin originalName ] ifNone: [ nil ].! !

!PackageOrganizer methodsFor: '*rpackage-core' stamp: 'cyrilledelaunay 1/31/2011 14:50'!
packagesDictionary

	^ packages! !

!TraitDescription methodsFor: '*rpackage-core' stamp: 'StephaneDucasse 6/3/2012 22:48'!
extendingPackages
	"the extending packages of a class are the packages that extend it."
	^ RPackage organizer extendingPackagesOf: self
	! !

!TraitDescription methodsFor: '*rpackage-core' stamp: 'cyrille.delaunay 11/26/2010 16:41'!
isDefinedInPackage: aPackage
	"returns true if aPackage contains the definitino of this class"
	
	^ aPackage includesClass: self.
	! !

!TraitDescription methodsFor: '*rpackage-core' stamp: 'cyrille.delaunay 11/26/2010 16:41'!
isExtended

	^ self extendingPackages isEmpty! !

!TraitDescription methodsFor: '*rpackage-core' stamp: 'cyrille.delaunay 11/26/2010 16:41'!
isExtendedInPackage: aPackage
	"returns true if aPackage defines an extension to this class"
	^ aPackage extendsClass: self.
	! !

!TraitDescription methodsFor: '*rpackage-core' stamp: 'StephaneDucasse 6/3/2012 22:48'!
package
	^ RPackage organizer packageOf: self.	! !

!TraitDescription methodsFor: '*rpackage-core' stamp: 'cyrille.delaunay 11/26/2010 16:41'!
packageFromOrganizer: anOrganizer
	"returns the package that defines this class"
	^ anOrganizer packageOf: self.
	! !

!TraitDescription methodsFor: '*rpackage-core' stamp: 'StephaneDucasse 6/3/2012 22:48'!
packageOrganizer
	^ RPackage organizer ! !

!TraitDescription methodsFor: '*rpackage-core' stamp: 'cyrille.delaunay 11/26/2010 16:41'!
packages
	"the extending packages of a class are the packages that extend it."
	
	^  self extendingPackages asSet copy add: self package; yourself! !

!Announcer methodsFor: '*RPackage-core' stamp: 'StephaneDucasse 4/23/2011 20:28'!
hasSubscriber: anObject

	registry subscriptionsOf: anObject  do: [:each | ^ true].
	^ false! !

!Announcer methodsFor: '*RPackage-core' stamp: 'StephaneDucasse 4/23/2011 12:43'!
subscriptions

	^ registry! !

!SystemNavigation methodsFor: '*RPackage-Core' stamp: 'StephaneDucasse 6/3/2012 23:23'!
packageFromPattern: pattern withCaption: aCaption
	"If there is a package whose name exactly given by pattern, return it.
	If there is only one package in the system whose name matches pattern, return it.
	Otherwise, put up a menu offering the names of all packages that match pattern, and return the class chosen, else nil if nothing chosen.
	This method ignores tab, space, & cr characters in the pattern"

	| toMatch potentialPackageNames packageNames exactMatch index |
	(toMatch := pattern
		copyWithoutAll:
			{(Character space).
			(Character cr).
			(Character tab)}) isEmpty
		ifTrue: [ ^ nil ].
	
	self packageOrganizerClass default packageNamed: toMatch ifAbsent: [ nil ].
	
	toMatch := (toMatch copyWithout: $.) asLowercase.
	potentialPackageNames := (self packageOrganizerClass default packages collect: [:each | each name]) asOrderedCollection.
	packageNames := pattern last = $.
		ifTrue: [ potentialPackageNames select: [ :nm | nm asLowercase = toMatch ] ]
		ifFalse: [ potentialPackageNames select: [ :n | n includesSubstring: toMatch caseSensitive: false ] ].
	packageNames isEmpty
		ifTrue: [ ^ nil ].
	exactMatch := packageNames detect: [ :each | each asLowercase = toMatch ] ifNone: [ nil ].
	index := packageNames size = 1
		ifTrue: [ 1 ]
		ifFalse: [ 
			exactMatch
				ifNil: [ UIManager default chooseFrom: packageNames lines: #() title: aCaption ]
				ifNotNil: [ 
					packageNames addFirst: exactMatch.
					UIManager default chooseFrom: packageNames lines: #(1) title: aCaption ] ].
	index = 0
		ifTrue: [ ^ nil ].
	^ self packageOrganizerClass default packageNamed: (packageNames at: index)"
	self default packageFromPattern: 'Nau' withCaption: ''
	self default packageFromPattern: 'orph' withCaption: ''
	self default packageFromPattern: 'TCompil' withCaption: ''
"! !

!SystemNavigation methodsFor: '*RPackage-Core' stamp: 'StephaneDucasse 6/3/2012 23:22'!
packageOrganizerClass
	^ RPackageOrganizer! !

Object subclass: #RPackage
	instanceVariableNames: 'classDefinedSelectors metaclassDefinedSelectors classExtensionSelectors metaclassExtensionSelectors classes name classTags'
	classVariableNames: 'PackageGlobalOrganizer'
	poolDictionaries: ''
	category: 'RPackage-Core'!

!RPackage commentStamp: 'StephaneDucasse 7/25/2011 21:55' prior: 0!
A RPackage is a new implementation of package. Note that it does not touch classes but it is just a layer on top of classes therefore removing a method from a package does not change the underlying class. 


Instance Variables
	classDefinedSelectors:		Dictionary
	classExtensionSelectors:		Dictionary
	metaclassDefinedSelectors:		Dictionary
	metaclassExtensionSelectors:		Dictionary
	packageName:		String
	classes: OrderedCollection of Symbols
	classTags: is a mapping from tags to classNames

The reason we use four dictionaries is that this way we only store #Point in both as the class and the metaclass are involved. We do not have to with Point_class problem when comparing defined and extended classes. The idea is taken from the RBSelectorEnvironment. 					
		
Class Invariant one:
	Classes should not contain metaclass name, but only class names
	
	

Implementation notes 
====================
This class went over 3 internal representations implementation. 
	- first: 	a list of class + two dictionaries: class * methods
	This was not good since we add to go all the time over the list of classes.
	- second: 4 dictionaries class * selectors 
	This was not good since we want to have defined classes without methods. 
	- third: 4 dictionaries + definedClasses

Originally I wanted to avoid to have a defined class list and I wanted to avoid to have to declare the class as defined. But this is not really good since
	- we will want to know if a class definition (without method for example is defined in a given package)
	- second this is easier to hook the packageOf: behavior (we register the package class when the class is 	added to the package).

defined classes information is redundant with the dictionary keys of defined methods but we would have to check and register the class to the packageOrganizer the first time a method is defined then also check on remove to unregister the class from the packageOrganizer.

Adding a method does not define the class as a defined package class. This has to be done explictly. The reason for this choice is that a class should register to the packageOrganizer and that I do not want to do it each time a method is added and I do not want to test it each time a method is added. Now this is done only when the class is declared as defined. 
We could also give the complete freedom to the client to register the class but I thought it was a good compromise. 
	
	
ClassTag are tags that can be associated to classes. They help user organizing their class internal. 
So that we can have a package infrastructure as follows:
	Package1
		ClassA
		ClassB
	in case there is no tags associated to the package
	or
	Package2	
		Tag1
			ClassA
			ClassB
		Tag2
			ClassC
			ClassD
			ClassE
			ClassA		
	
Todo
====
	Next: 
	- finish 
	- build up a synchronizer that import PackageInfo.
	

	

	
!

!RPackage class methodsFor: 'constants' stamp: 'StephaneDucasse 4/29/2011 21:04'!
defaultPackageName
	^ #'_UnpackagedPackage'! !

!RPackage class methodsFor: 'help' stamp: 'StephaneDucasse 6/3/2012 23:28'!
help
	<wikiStyleHelp: 'RPackage'>	
	|stream|
	stream := String new writeStream.
	stream 
		nextPut: $!!;
		nextPutAll: self name asString;
		cr;
		nextPutAll: self comment;
		cr;
		nextPut: $!!;
		nextPutAll: self packageOrganizerClass name asString;
		cr;
		nextPutAll: self packageOrganizerClass comment.		
	^stream contents
	
	! !

!RPackage class methodsFor: 'class initialization' stamp: 'StephaneDucasse 6/3/2012 23:28'!
initialize
	"self initialize"
	
	super initialize.
	self organizer: self packageOrganizerClass default.
! !

!RPackage class methodsFor: 'instance creation' stamp: 'StephaneDucasse 4/13/2011 22:43'!
named: aString

	| newPackage |
	newPackage := self new name: aString ;yourself.
	^ newPackage! !

!RPackage class methodsFor: 'protected only for tests' stamp: 'EstebanLorenzano 7/27/2012 20:30'!
organizer
	^ PackageGlobalOrganizer ifNil: [ RPackageOrganizer default ].! !

!RPackage class methodsFor: 'protected only for tests' stamp: 'cyrille.delaunay 10/29/2010 14:31'!
organizer: aPackageOrganizer

	PackageGlobalOrganizer := aPackageOrganizer! !

!RPackage class methodsFor: 'class initialization' stamp: 'StephaneDucasse 6/3/2012 23:27'!
packageOrganizerClass
	^ RPackageOrganizer
! !

!RPackage class methodsFor: 'protected only for tests' stamp: 'StephaneDucasse 4/24/2011 16:45'!
withOrganizer: aNewOrganizer do: aBlock
	"Perform an action locally to aNewOrganizer. Does not impact any other organizers."
	
	| old |
	[ old := self organizer.
	old unregister.
	self organizer: aNewOrganizer.
	aNewOrganizer register.
	aBlock cull: aNewOrganizer] ensure: [ 
		self organizer: old. 
		old register.
		aNewOrganizer unregister] ! !

!RPackage methodsFor: 'class addition' stamp: 'DamienPollet 10/1/2010 11:37'!
addClassDefinition: aClass
	"Add only the class definition of aClass, as a class defined by the receiver. The term classdefinition denotes the fact that we do not treat its methods. aClass methods are not added to the package. aClass can be either a class or a metaclass"
	
	self addClassDefinitionName: aClass theNonMetaClass name.
	! !

!RPackage methodsFor: 'class tags' stamp: 'CamilleTeruel 7/16/2012 16:46'!
addClassDefinition: aClass toClassTag: aSymbol
	"Tags the class aClass with the tag aSymbol"
	
	self addClassDefinitionName: aClass name toClassTag: aSymbol! !

!RPackage methodsFor: 'class addition' stamp: 'cyrilledelaunay 2/22/2011 13:32'!
addClassDefinitionName: aClassName
	"aClassName should only be a class (and not a metaclass name)"

	| aClassNameSymbol |
	('* class' match: aClassName)
		ifTrue: [ ^ self error: 'no metaclass name' ].
	aClassNameSymbol := aClassName asSymbol.
	(classes includes: aClassNameSymbol)
		ifTrue: [ ^ self ].
	classes add: aClassNameSymbol.
	self extendedMethodsShouldBecomeDefinedWhenAddingClassName: aClassNameSymbol.
	self registerClassName: aClassNameSymbol! !

!RPackage methodsFor: 'class tags' stamp: 'StephaneDucasse 7/25/2011 23:39'!
addClassDefinitionName: aClassName toClassTag: aSymbol
	"Tags the class aClass with the tag aSymbol"
	
	| res |
	res := classTags at: aSymbol ifAbsent: [nil].
	res isNil
		ifTrue: [classTags at: aSymbol put: (Set new add: aClassName; yourself)]
		ifFalse: [res add: aClassName].
	! !

!RPackage methodsFor: 'class tags' stamp: 'StephaneDucasse 7/26/2011 00:20'!
addClassTag: aSymbol
	"Add the class tag from the receiver, if already added do nothing."
	
	classTags at: aSymbol ifAbsentPut: [Set new] ! !

!RPackage methodsFor: 'compiled method handling' stamp: 'CamilloBruni 7/11/2012 09:27'!
addMethod: aCompiledMethod 
	"Add the method to the receiver as a defined method if the class is  defined in it, else as an extension."

	| methodClass |
	methodClass := aCompiledMethod methodClass. 
	(self includesClass: methodClass )
		ifFalse: [methodClass isMeta
					ifTrue: [(metaclassExtensionSelectors 
								at: methodClass theNonMetaClass name  
								ifAbsentPut: [Set new]) add: aCompiledMethod selector.]
					ifFalse: [(classExtensionSelectors 
								at: methodClass name 
								ifAbsentPut: [Set new]) add: aCompiledMethod selector].
				"we added a method extension so the receiver is an extending package of the class"
				self organizer registerExtendingPackage: self forClass: methodClass]
		ifTrue: [methodClass isMeta
					ifTrue: [(metaclassDefinedSelectors 
								at: methodClass theNonMetaClass name  
								ifAbsentPut: [Set new]) add: aCompiledMethod selector]
					ifFalse: [(classDefinedSelectors 
								at: methodClass name 
								ifAbsentPut: [Set new]) add: aCompiledMethod selector]].	
	^ aCompiledMethod.! !

!RPackage methodsFor: 'selector handling' stamp: 'StephaneDucasse 4/20/2010 22:56'!
addSelector: aSelector ofClassName: aClassName
	"Add the method to the receiver. If the class is not locally defined in that package then the method is defined as a method extension: ie extending another package. Note that this method does not add the method to the class, it just records in the package that the method is packaged."
	
	( self includesClassNamed: aClassName)
		ifFalse: [(classExtensionSelectors at: aClassName asSymbol ifAbsentPut: [Set new]) add: aSelector]
		ifTrue: [(classDefinedSelectors at: aClassName asSymbol ifAbsentPut: [Set new]) add: aSelector].
	^ aSelector.! !

!RPackage methodsFor: 'selector handling' stamp: 'StephaneDucasse 4/20/2010 22:56'!
addSelector: aSelector ofMetaclassName: aClassName
	"Add the method to the receiver. If the class is not locally defined in that package then the method is defined as a method extension: ie extending another package. Note that this method does not add the method to the class, it just records in the package that the method is packaged. aClassName is the sole instance class name and not its metaclass one: i.e. adding Point class>>new is done as addSelector: #new ofMetaclassName: #Point"
	
	( self includesClassNamed: aClassName) 
		ifFalse: [(metaclassExtensionSelectors at: aClassName asSymbol ifAbsentPut: [Set new]) add: aSelector]
		ifTrue: [(metaclassDefinedSelectors at: aClassName asSymbol ifAbsentPut: [Set new]) add: aSelector].
	^ aSelector.! !

!RPackage methodsFor: 'system compatibility' stamp: 'StephaneDucasse 4/27/2011 20:16'!
allDefinedClasses
	
	"this method should return the same thing than PackageInfo >> classes. 
	This raised another problem: When asking a PackageInfo for its classes , it returns all classes included in this packageInfo and in all sub-categories. We should provide such accessor to stay compatible.
	(RPackageOrganizer default packageNamed: 'HelpSystem-Core' asSymbol) allDefinedClasses.
	(PackageInfo named: 'HelpSystem-Core' asSymbol) classes.
	(PackageInfo named: 'HelpSystem-Core' asSymbol) classes reject: [:each | (RPackageOrganizer default packageNamed: 'HelpSystem-Core' asSymbol) allDefinedClasses includes: each]. 	(RPackageOrganizer default packageNamed: 'CollectionsTests' asSymbol) allDefinedClasses sort: [:a :b | a name < b name].
	(PackageInfo named: 'CollectionsTests' asSymbol) classes.
	"
	|tmpClasses|
	self flag: #stef. "no sender"
	tmpClasses := OrderedCollection new.
	self systemSubPackages do: [:tmpPackage |
		tmpClasses addAll: tmpPackage definedClasses.
		].
	^ tmpClasses addAll: self definedClasses; yourself! !

!RPackage methodsFor: 'system compatibility' stamp: 'StephaneDucasse 4/27/2011 20:16'!
allMethodReferences
	
	"this method should return the same thing that PackageInfo >> methods. 
	This raised another problem: When asking a PackageInfo for its methods (it's the same for classes), it returns all methods included in this packageInfo and in all sub-categories. We should privide such accessor to stay compatible.
	(RPackageOrganizer default packageNamed: 'HelpSystem-Core' asSymbol) allMethodReferences.
	(PackageInfo named: 'HelpSystem-Core' asSymbol) methods
	"
	"(RPackageOrganizer default packageNamed: 'Settings-System' asSymbol) allMethodReferences.
	(PackageInfo named: 'Settings-System' asSymbol) methods"
	"
	(RPackageOrganizer default packageNamed: 'CollectionsTests' asSymbol) allMethodReferences.
	(PackageInfo named: 'CollectionsTests' asSymbol) methods
	"
	|tmpMethods|
	self flag: #stef. "no senders"
	tmpMethods := OrderedCollection new.
	self systemSubPackages do: [:tmpPackage |
		tmpMethods addAll: tmpPackage methodReferences.
		].
	^ tmpMethods addAll: self methodReferences; yourself! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:33'!
allOverriddenMethodsDo: aBlock
	"Evaluates aBlock with all the overridden methods in the system"
	^ ProtoObject withAllSubclassesDo: [:class | 
		self overriddenMethodsInClass: class do: aBlock]
! !

!RPackage methodsFor: 'selector handling' stamp: 'GuillermoPolito 5/29/2012 14:04'!
basicRemoveSelector: aSelector ofClassName: aClassName
	"Remove the method in the package but does not propagate to the class itself.  Note that this method does not remove the method from the class, it just records in the package that the method is not in the package anymore."
	
	( self includesClassNamed: aClassName)
		ifFalse: [(classExtensionSelectors  at: aClassName ifAbsent: [ ^ Set new]) remove: aSelector.]
		ifTrue: [(classDefinedSelectors  at: aClassName ifAbsent: [ ^ Set new]) remove: aSelector.].
	
	! !

!RPackage methodsFor: 'selector handling' stamp: 'GuillermoPolito 5/29/2012 14:04'!
basicRemoveSelector: aSelector ofMetaclassName: aClassName
	"Remove the method in the package. Note that this method does not remove the method from the class, it just records in the package that the method is not in the package anymore. aClassName is the sole instance class name and not its metaclass one: i.e. adding Point class>>new is done as removeSelector: #new ofMetaclassName: #Point"
	
	( self includesClassNamed: aClassName)
		ifFalse: [(metaclassExtensionSelectors  at: aClassName ifAbsent: [ ^ Set new]) remove: aSelector.]
		ifTrue: [(metaclassDefinedSelectors  at: aClassName ifAbsent: [ ^ Set new]) remove: aSelector.].
	
	! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:33'!
category: categoryName matches: prefix
	"self default category: 'Compression-Archives' matches: 'Compression'"
	"self default category: 'Compression' matches: 'Compression-Archives'"
	"self default category: 'Compression' matches: 'Compression'"
	"self default category: 'Compression-Arh' matches: 'Compression'"
	| prefixSize catSize |
	categoryName ifNil: [ ^false ].
	catSize := categoryName size.
	prefixSize := prefix size.
	catSize < prefixSize ifTrue: [ ^false ].
	(categoryName findString: prefix startingAt: 1 caseSensitive: false) = 1
		ifFalse: [ ^false ].
	^(categoryName at: prefix size + 1 ifAbsent: [ ^true ]) = $-! !

!RPackage methodsFor: 'system compatibility' stamp: 'cyrilledelaunay 2/2/2011 16:07'!
changeRecordForOverriddenMethod: aMethodReference
	| sourceFilesCopy method position |
	method := aMethodReference actualClass compiledMethodAt: aMethodReference methodSymbol.
	position := method filePosition.
	sourceFilesCopy := SourceFiles
		collect: [ :x | 
			x isNil
				ifTrue: [ nil ]
				ifFalse: [ x readOnlyCopy ] ].
	[ 
	| file prevPos prevFileIndex chunk stamp methodCategory tokens |
	method fileIndex == 0
		ifTrue: [ ^ nil ].
	file := sourceFilesCopy at: method fileIndex.
	[ position notNil & file notNil ]
		whileTrue: [ 
			file position: (0 max: position - 150).	"Skip back to before the preamble"
			[ file position < (position - 1) ] whileTrue: [ chunk := file nextChunk ].	"then pick it up from the front"	"Preamble is likely a linked method preamble, if we're in
			a changes file (not the sources file).  Try to parse it
			for prior source position and file index"
			prevPos := nil.
			stamp := ''.
			(chunk findString: 'methodsFor:' startingAt: 1) > 0
				ifTrue: [ tokens := Scanner new scanTokens: chunk ]
				ifFalse: [ tokens := Array new	"ie cant be back ref" ].
			((tokens size between: 7 and: 8) and: [ (tokens at: tokens size - 5) = #methodsFor: ])
				ifTrue: [ 
					(tokens at: tokens size - 3) = #stamp:
						ifTrue: [ 
							"New format gives change stamp and unified prior pointer"
							stamp := tokens at: tokens size - 2.
							prevPos := tokens last.
							prevFileIndex := sourceFilesCopy fileIndexFromSourcePointer: prevPos.
							prevPos := sourceFilesCopy filePositionFromSourcePointer: prevPos ]
						ifFalse: [ 
							"Old format gives no stamp; prior pointer in two parts"
							prevPos := tokens at: tokens size - 2.
							prevFileIndex := tokens last ].
					(prevPos = 0 or: [ prevFileIndex = 0 ])
						ifTrue: [ prevPos := nil ] ].
			((tokens size between: 5 and: 6) and: [ (tokens at: tokens size - 3) = #methodsFor: ])
				ifTrue: [ 
					(tokens at: tokens size - 1) = #stamp:
						ifTrue: [ 
							"New format gives change stamp and unified prior pointer"
							stamp := tokens at: tokens size ] ].
			methodCategory := tokens after: #methodsFor: ifAbsent: [ 'as yet unclassifed' ].
			(self includesMethodCategory: methodCategory ofClass: aMethodReference actualClass)
				ifTrue: [ 
					methodCategory = (Smalltalk globals at: #Categorizer ifAbsent: [ Smalltalk globals at: #ClassOrganizer ]) default
						ifTrue: [ methodCategory := methodCategory , ' ' ].
					^ ChangeRecord new
						file: file
						position: position
						type: #method
						class: aMethodReference classSymbol
						category: methodCategory
						meta: aMethodReference classIsMeta
						stamp: stamp ].
			position := prevPos.
			prevPos notNil
				ifTrue: [ file := sourceFilesCopy at: prevFileIndex ] ].
	^ nil ]
		ensure: [ 
			sourceFilesCopy
				do: [ :x | 
					x notNil
						ifTrue: [ x close ] ] ]! !

!RPackage methodsFor: 'slices' stamp: 'StephaneDucasse 3/11/2010 18:46'!
classDefinedSlicesDo: aBlock
	"This method iterates over the defined class and their associated selectors. a slice is a class * list of selectors. aBlock will be applied to all the extensions slices of the receiver. aBlok first argument is the class and the second argument a list of method selectors"
	
	classDefinedSelectors keysAndValuesDo: aBlock! !

!RPackage methodsFor: 'slices' stamp: 'DamienPollet 10/1/2010 11:48'!
classExtensionSlicesDo: aBlock
	"This method iterates over the class extensions and their associated selectors. A slice is a class * list of selectors. aBlock will be applied to all the extensions slices of the receiver. aBlock first argument is the class and the second argument a list of method selectors"
	
	classExtensionSelectors keysAndValuesDo: aBlock! !

!RPackage methodsFor: 'slices' stamp: 'StephaneDucasse 3/11/2010 18:40'!
classNamesAndExtensionSelectorsDo: aBlock
	"Iterate over the extended methods grouped by classes and apply the argument.
	The block will be passed a class name and each individual selectors.
	Only classes with methods are paired with their methods"
	
	classExtensionSelectors keysAndValuesDo: [ :classSymbol :methods |
			methods do: [ :sel |  aBlock value: classSymbol	value: sel]].
	
	metaclassExtensionSelectors keysAndValuesDo: [ :classSymbol :methods |
			methods do: [ :sel |  aBlock 
									value: (classSymbol, '_class') asSymbol
									value: sel]].	! !

!RPackage methodsFor: 'all accessing' stamp: 'sd 4/25/2010 16:03'!
classes
	"Return all the classes"
	
	^ self definedClasses, self extendedClasses 
	
	! !

!RPackage methodsFor: 'system compatibility' stamp: 'StephaneDucasse 4/27/2011 11:35'!
classesAndMetaClasses
	"Return a Set with all classes and metaclasses belonging to this package"
	self flag: #stef. "only used by goferCleanUp"
	^ OrderedCollection new
		addAll: self definedClasses;
		addAll: (self definedClasses collect: [:each | each classSide]);
		yourself.! !

!RPackage methodsFor: 'class tags' stamp: 'StephaneDucasse 7/25/2011 22:20'!
classesForClassTag: aSymbol
	"Returns the classes tagged using aSymbol"
	
	^ classTags at: aSymbol ifAbsent: [Array new]! !

!RPackage methodsFor: 'system compatibility' stamp: 'StephaneDucasse 4/27/2011 11:35'!
coreCategoriesForClass: aClass

	self flag: #stef. "only used by goferCleanUp"
	^ aClass organization categories reject: [ :cat | self isForeignClassExtension: cat ]! !

!RPackage methodsFor: 'all accessing' stamp: 'StephaneDucasse 3/11/2010 15:17'!
definedClassNames 
	"Return the class names having methods defined in the receiver."
	
	^ classes! !

!RPackage methodsFor: 'all accessing' stamp: 'CamilloBruni 4/27/2012 13:26'!
definedClasses 
	| definedClasses |
	definedClasses := Set new.
	classes do: [:each | 
		Smalltalk globals 
			at: each 
			ifPresent: [:aClass| definedClasses add: aClass ]].
	^ definedClasses
	! !

!RPackage methodsFor: 'iteration' stamp: 'StephaneDucasse 2/21/2010 17:25'!
definedClassesDo: aBlock

	classDefinedSelectors keysDo: aBlock.
	metaclassDefinedSelectors keysDo: aBlock.! !

!RPackage methodsFor: 'private' stamp: 'StephaneDucasse 4/25/2011 12:26'!
definedMethodsBecomeExtendedForClass: aClassName
	"the package may contain defined methods and their class is removed to the receiver. The status of such methods should now be extended"
	"Precondition: aClassName is in the defined list"
	
	| ext |
	(classDefinedSelectors keys includes: aClassName) ifFalse: [^ self].
	ext := classDefinedSelectors at: aClassName.
	classDefinedSelectors removeKey: aClassName ifAbsent: [self reportBogusBehaviorOf:   #definedMethodsBecomeExtendedForClass: ].
	(classExtensionSelectors keys includes: aClassName) ifTrue: [self error: aClassName , ' should not be defined in extension'.]. "we should remove this check later"
	classExtensionSelectors at: aClassName put: ext.! !

!RPackage methodsFor: 'private' stamp: 'StephaneDucasse 4/25/2011 12:27'!
definedMethodsBecomeExtendedForMetaclass: aClassName
	"the package may contain defined methods and their class is removed to the receiver. The status of such methods should now be extended"
	"Precondition: aClassName is in the defined list"
	
	| ext |
	(metaclassDefinedSelectors keys includes: aClassName) ifFalse: [^ self].
	ext := metaclassDefinedSelectors at: aClassName.
	metaclassDefinedSelectors removeKey: aClassName ifAbsent: [self reportBogusBehaviorOf: #definedMethodsBecomeExtendedForMetaclass:].
	(metaclassExtensionSelectors keys includes: aClassName) ifTrue: [self error: aClassName , ' should not be defined in extension'.]. "we should remove this check later"
	metaclassDefinedSelectors at: aClassName put: ext.! !

!RPackage methodsFor: 'accessing' stamp: 'StephaneDucasse 4/13/2011 22:17'!
definedMethodsForClass: aClass

	^ (self definedSelectorsForClass: aClass) asOrderedCollection collect: [ :each | aClass >> each ]! !

!RPackage methodsFor: 'private' stamp: 'sd 4/25/2010 15:41'!
definedMethodsShouldBecomeExtensionWhenRemovingClass: aClassName
	"the package may contain defined methods and their class is removed from the receiver. The status of such methods should now be extensions"
	
	self definedMethodsBecomeExtendedForClass: aClassName.
	self definedMethodsBecomeExtendedForMetaclass: aClassName.! !

!RPackage methodsFor: 'accessing' stamp: 'tg 3/13/2010 13:31'!
definedSelectorsForClass: aClass

	^ aClass isMeta
		ifTrue: [ metaclassDefinedSelectors at: aClass theNonMetaClass name ifAbsent: [ #() ] ]
		ifFalse: [ classDefinedSelectors at: aClass name ifAbsent: [ #() ] ]! !

!RPackage methodsFor: 'testing' stamp: 'StephaneDucasse 4/20/2010 22:22'!
definesClass: aClass
	"Returns true if the class, aClass, is one of the locally defined classes"
	"should be probably removed since this is the same as includesClass: or the inverse"
	^ self includesClass: aClass! !

!RPackage methodsFor: 'testing' stamp: 'sd 4/25/2010 16:06'!
definesOrExtendsClass: aClass
	"Returns true whether the class, aClass, is one of the locally defined classes of the receiver or 
	if the receiver extends such class (that is defined in another package)"
	
	| canonizedName |
	canonizedName := aClass theNonMetaClass name.
	^ (classes includes: canonizedName) 
		or: [self extendedClassNames includes:  canonizedName]
! !

!RPackage methodsFor: 'accessing' stamp: 'sd 4/25/2010 16:06'!
extendedClassNames 
	"Return the name of the classes which are extended by the receiver package. if a metaclass is extended, just get its sole instance class name."
	
	^ classExtensionSelectors keys union: metaclassExtensionSelectors keys! !

!RPackage methodsFor: 'accessing' stamp: 'CamilloBruni 5/23/2012 17:08'!
extendedClasses 
	"Return classes and metaclasses that are extended in the receiver"
	^ (metaclassExtensionSelectors keys 
		select: [ :each| Smalltalk globals includesKey: each ]
		thenCollect: [:each | (Smalltalk globals at: each) class])
			union:  (classExtensionSelectors keys 
						select: [ :each| Smalltalk globals includesKey: each ]
						thenCollect: [:each | Smalltalk globals at: each])! !

!RPackage methodsFor: 'private' stamp: 'StephaneDucasse 4/25/2011 12:26'!
extendedMethodsBecomeDefinedForClass: aClassName
	"the package may contain extension methods and their class is added to the receiver. The status of such methods should now be defined"
	"Precondition: aClassName is in the defined list"
	
	| ext |
	(classExtensionSelectors keys includes: aClassName) ifFalse: [^ self].
	ext := classExtensionSelectors at: aClassName.
	classExtensionSelectors removeKey: aClassName ifAbsent: [self reportBogusBehaviorOf:   #extendedMethodsBecomeDefinedForClass: ].
	(classDefinedSelectors keys includes: aClassName) ifTrue: [self error: aClassName , ' should not be defined in extension'.]. "we should remove this check later"
	classDefinedSelectors at: aClassName put: ext.! !

!RPackage methodsFor: 'private' stamp: 'StephaneDucasse 4/25/2011 12:25'!
extendedMethodsBecomeDefinedForMetaclass: aClassName
	"the package may contain extension methods and their class is added to the receiver. The status of such methods should now be defined"
	"Precondition: aClassName is in the defined list"
	
	| ext |
	(metaclassExtensionSelectors keys includes: aClassName) ifFalse: [^ self].
	ext := metaclassExtensionSelectors at: aClassName.
	metaclassExtensionSelectors removeKey: aClassName  ifAbsent: [self reportBogusBehaviorOf:  #extendedMethodsBecomeDefinedForMetaclass: ].
	(metaclassDefinedSelectors keys includes: aClassName) 
			ifTrue: [self error: aClassName , ' should not be defined in extension'.]. "we should remove this check later"
	metaclassDefinedSelectors at: aClassName put: ext.! !

!RPackage methodsFor: 'private' stamp: 'sd 4/25/2010 15:29'!
extendedMethodsShouldBecomeDefinedWhenAddingClassName: aClassName
	"the package may contain extension methods and their class is added to the receiver. The status of such methods should now be defined"
	"Precondition: aClassName is in the defined list"
	
	self extendedMethodsBecomeDefinedForClass: aClassName.
	self extendedMethodsBecomeDefinedForMetaclass: aClassName.
	! !

!RPackage methodsFor: 'testing' stamp: 'sd 4/25/2010 16:05'!
extendsClass: aClass
	"Returns true if the receiver extends aClass (that is defined in another package)"
	
	| canonizedName |
	canonizedName := aClass theNonMetaClass name.
	^ self extendedClassNames includes:  canonizedName! !

!RPackage methodsFor: 'system compatibility' stamp: 'StephaneDucasse 4/27/2011 11:37'!
extensionCategoriesForClass: aClass
	self flag: #stef. "only used by goferCleanUp and PackageEnvironment of RB"
	^ aClass organization categories select: [:cat | self isYourClassExtension: cat]! !

!RPackage methodsFor: 'system compatibility' stamp: 'StephaneDucasse 4/27/2011 11:37'!
extensionClasses
	self flag: #stef. "only used by RB and Gofer"
	^ self extendedClasses! !

!RPackage methodsFor: 'accessing' stamp: 'cyrille.delaunay 10/27/2010 13:04'!
extensionMethods
	"Extension methods are methods defined on classes that are not defined in the receiver"
	
	| mthds |
	mthds := OrderedCollection new.
	classExtensionSelectors keysAndValuesDo: [ :classSymbol :methods |
			methods do: [ :sel | mthds add: ((Smalltalk at: classSymbol) >>	sel)]].
	metaclassExtensionSelectors
	 keysAndValuesDo: [ :classSymbol :methods |
			methods do: [ :sel | mthds add: ((Smalltalk at: classSymbol) class >>sel)]].	
	^ mthds				! !

!RPackage methodsFor: 'accessing' stamp: 'tg 3/13/2010 14:18'!
extensionMethodsForClass: aClass

	^ (self extensionSelectorsForClass: aClass) collect: [ :each | aClass >> each ]! !

!RPackage methodsFor: 'accessing' stamp: 'DamienPollet 9/28/2010 17:09'!
extensionSelectors
	"Extension methods are methods defined on classes that are not defined in the receiver"
	
	| classSels |
	classSels := Set new.
	classExtensionSelectors values do: [:each | classSels addAll: each].
	metaclassExtensionSelectors values do: [:each | classSels addAll: each].
	^ classSels.
	! !

!RPackage methodsFor: 'accessing' stamp: 'StephaneDucasse 4/21/2010 14:05'!
extensionSelectorsForClass: aClass

	^ aClass isMeta
		ifTrue: [ metaclassExtensionSelectors at: aClass theNonMetaClass name ifAbsent: [ #() ] ]
		ifFalse: [ classExtensionSelectors at: aClass name ifAbsent: [ #() ] ]! !

!RPackage methodsFor: 'testing' stamp: 'StephaneDucasse 2/21/2010 17:56'!
includesClass: aClass	
	"Returns true if the receiver includes aClass in the classes that are defined within it: only class definition are considered - not class extensions"
	
	^ self includesClassNamed: aClass theNonMetaClass name! !

!RPackage methodsFor: 'testing' stamp: 'StephaneDucasse 4/20/2010 22:53'!
includesClassNamed: aSymbol
	"Returns true if the receiver includes class named aSymbol in the classes that are defined within it: only class definition are considered - not class extensions"
	
	| aRealSymbol |
	aRealSymbol := aSymbol asSymbol.
	^ classes includes: aSymbol
	! !

!RPackage methodsFor: 'testing' stamp: 'tg 3/13/2010 15:13'!
includesDefinedSelector: aSelector ofClass: aClass
	"Return true if the receiver includes the method of selector aSelector. Only checks methods defined in this package"
	
	| sels |
	sels := self definedSelectorsForClass: aClass.
	^ sels includes: aSelector.! !

!RPackage methodsFor: 'testing' stamp: 'StephaneDucasse 2/21/2010 18:53'!
includesDefinedSelector: aSelector ofClassName: aClassName
	"Return true if the receiver includes the method of selector aSelector. Only checks methods defined (not extended by other packages or package extensions)"
	
	| sels |
	sels := classDefinedSelectors at: aClassName ifAbsent: [^ false].
	^ sels includes: aSelector.! !

!RPackage methodsFor: 'testing' stamp: 'StephaneDucasse 2/21/2010 18:53'!
includesDefinedSelector: aSelector ofMetaclassName: aClassName
	"Return true if the receiver includes the method of selector aSelector. Only checks methods defined (not extended by other packages or package extensions)"
	
	| sels |
	sels := metaclassDefinedSelectors at: aClassName ifAbsent: [^ false].
	^ sels includes: aSelector.! !

!RPackage methodsFor: 'testing' stamp: 'tg 3/13/2010 13:47'!
includesExtensionSelector: aSelector ofClass: aClass
	"Return true if the receiver includes the method of selector aSelector. Only checks methods extending other packages"
	
	| sels |
	sels := self extensionSelectorsForClass: aClass.
	^ sels includes: aSelector.! !

!RPackage methodsFor: 'testing' stamp: 'StephaneDucasse 2/21/2010 18:54'!
includesExtensionSelector: aSelector ofClassName: aClassName
	"Return true if the receiver includes the method of selector aSelector. Only checks methods extending other packages"
	
	| sels |
	sels := classExtensionSelectors at: aClassName ifAbsent: [^ false].
	^ sels includes: aSelector.! !

!RPackage methodsFor: 'testing' stamp: 'StephaneDucasse 2/21/2010 18:54'!
includesExtensionSelector: aSelector ofMetaclassName: aClassName
	"Return true if the receiver includes the method of selector aSelector. Only checks methods extending other packages"
	
	| sels |
	sels := metaclassExtensionSelectors at: aClassName ifAbsent: [^ false].
	^ sels includes: aSelector.! !

!RPackage methodsFor: 'system compatibility' stamp: 'cyrilledelaunay 5/4/2011 15:38'!
includesMethod: aSymbol ofClass: aClass

	self flag: #stef. "only used by RB"
	self flag: #cyrille. "looks like a bogus implementation because category have nothing to do with the fact that a method is in package or not."
	"CD: Indeed, it looks strange. 
	With RPackage we have 'includesSelector:ofClass:. I guess it should return the same result (?)'
	"
	aClass ifNil: [^ false].
	^ self
		includesMethodCategory: ((aClass organization categoryOfElement: aSymbol)
										ifNil: [' '])
		ofClass: aClass! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:33'!
includesMethodCategory: categoryName ofClass: aClass
	^ (self isYourClassExtension: categoryName)
		or: [(self includesClass: aClass)
				and: [(self isForeignClassExtension: categoryName) not]]! !

!RPackage methodsFor: 'system compatibility' stamp: 'StephaneDucasse 4/27/2011 11:44'!
includesMethodReference: aMethodRef

	self flag: 'includesMethod:ofClass: is not implemented for RPackage. Should fine fine a corresponding one '.
	self flag: #stef. "We can inline this one and replace it by methodSymbol and others."
	^ self includesMethod: aMethodRef methodSymbol ofClass: aMethodRef actualClass
	"^ self includesDefinedSelector: aMethodRef methodSymbol ofClass: aMethodRef actualClass"! !

!RPackage methodsFor: 'testing' stamp: 'tg 3/13/2010 16:42'!
includesSelector: aSelector ofClass: aClass
	"Return true if the receiver includes the method of selector aSelector. Checks methods defined locally as well as extending other packages"
	
	^ aClass isMeta
		ifTrue: [ self includesSelector: aSelector ofMetaclassName: aClass theNonMetaClass name  ]
		ifFalse: [ self includesSelector: aSelector ofClassName: aClass name  ]
	
! !

!RPackage methodsFor: 'testing' stamp: 'StephaneDucasse 2/21/2010 20:50'!
includesSelector: aSelector ofClassName: aClassName
	"Return true if the receiver includes the method of selector aSelector. Checks methods defined locally as well as extending other packages"
	
	^ (self includesDefinedSelector: aSelector ofClassName: aClassName)
		or: [(self includesExtensionSelector: aSelector ofClassName: aClassName)]! !

!RPackage methodsFor: 'testing' stamp: 'StephaneDucasse 3/11/2010 17:38'!
includesSelector: aSelector ofMetaclassName: aClassName
	"Return true if the receiver includes the method of selector aSelector. Checks methods defined locally as well as extending other packages"
	
	^ (self includesDefinedSelector: aSelector ofMetaclassName: aClassName)
		or: [(self includesExtensionSelector: aSelector ofMetaclassName: aClassName)]! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:33'!
includesSystemCategory: categoryName
	^ self category: categoryName matches: self systemCategoryPrefix! !

!RPackage methodsFor: 'initialize-release' stamp: 'StephaneDucasse 7/25/2011 21:47'!
initialize
	super initialize.	
	classes := Set new.
	metaclassExtensionSelectors := Dictionary new.
	classExtensionSelectors := Dictionary new.
	classDefinedSelectors := Dictionary new.
	metaclassDefinedSelectors := Dictionary new.
	classTags := Dictionary new.! !

!RPackage methodsFor: 'testing' stamp: 'StephaneDucasse 4/18/2011 12:14'!
isDefault
	"Return whether the receiver is the default package, i.e. the one used when nothing else is specified."
	^ self name = self class defaultPackageName! !

!RPackage methodsFor: 'system compatibility' stamp: 'BenjaminVanRyseghem 3/30/2011 12:41'!
isDirty

	| modifiedPackages packages |
	modifiedPackages := MCWorkingCopy allManagers select: [ :each | each modified ].
	packages := modifiedPackages collect: [:each | each package name].
	^ packages includes: self name.! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:33'!
isForeignClassExtension: categoryName
	^ categoryName first = $* and: [(self isYourClassExtension: categoryName) not]! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:34'!
isOverrideCategory: aString
	^ aString endsWith: '-override'! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:34'!
isOverrideOfYourMethod: aMethodReference
	"Answers true if the argument overrides a method in this package"
	^ (self isYourClassExtension: aMethodReference category) not and:
		[(self changeRecordForOverriddenMethod: aMethodReference) notNil]! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:34'!
isYourClassExtension: categoryName
	^ categoryName notNil and: [self category: categoryName asLowercase matches: self methodCategoryPrefix]! !

!RPackage methodsFor: 'slices' stamp: 'StephaneDucasse 3/11/2010 18:47'!
metaclassDefinedSlicesDo: aBlock
	"This method iterates over the defined class and their associated selectors. a slice is a class * list of selectors. aBlock will be applied to all the extensions slices of the receiver. aBlok first argument is the class and the second argument a list of method selectors"
	
	metaclassDefinedSelectors keysAndValuesDo: aBlock! !

!RPackage methodsFor: 'slices' stamp: 'StephaneDucasse 4/20/2010 21:42'!
metaclassExtensionSlicesDo: aBlock
	"This method iterates over the metaclass extensions and their associated selectors. A slice is a class * list of selectors. aBlock will be applied to all the extensions slices of the receiver. aBlok first argument is the class and second argument a list of selectors"
	
	metaclassExtensionSelectors keysAndValuesDo: aBlock
	
! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:34'!
methodCategoryPrefix
	^ '*', self name asLowercase! !

!RPackage methodsFor: 'system compatibility' stamp: 'cyrilledelaunay 2/9/2011 13:46'!
methodReferences
	
	^ self methods collect: [:each | each methodReference] thenSelect: [:each| each isValid and: [each isLocalSelector]].! !

!RPackage methodsFor: 'all accessing' stamp: 'sd 4/21/2010 16:36'!
methods

	| mths |
	mths := OrderedCollection new.
	metaclassExtensionSelectors keysAndValuesDo: [:key :val | val do: [:sel | mths add: ((Smalltalk at: key) class >> sel)]].
	classExtensionSelectors keysAndValuesDo: [:key :val |val do: [:sel | mths add: ((Smalltalk at: key) >> sel)]].
	metaclassDefinedSelectors keysAndValuesDo: [:key :val | val do: [:sel | mths add: ((Smalltalk at: key) class >> sel)]].
	classDefinedSelectors keysAndValuesDo: [:key :val | val do: [:sel | mths add: ((Smalltalk at: key) >> sel)]].
	^ mths! !

!RPackage methodsFor: 'accessing' stamp: 'DamienPollet 9/28/2010 17:10'!
methodsForClass: aClass
	"Returns all compiled methods for a class in the receiver without distinction of extensions or not"
	
	^ (self includesClass: aClass)
		ifFalse: [self extensionMethodsForClass: aClass]
		ifTrue: [self definedMethodsForClass: aClass]
	! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:34'!
methodsInCategory: aString ofClass: aClass do: aBlock
	((aClass organization listAtCategoryNamed: aString) ifNil: [^self])
		do: [:sel | aBlock value: (self referenceForMethod: sel ofClass: aClass)]! !

!RPackage methodsFor: 'accessing' stamp: 'sd 4/25/2010 15:52'!
name

	^ name! !

!RPackage methodsFor: 'accessing' stamp: 'IgorStasenko 8/12/2011 16:36'!
name: aSymbol

	| oldName |
	oldName := name.
	name := aSymbol asSymbol.
	oldName ifNotNil: [ SystemAnnouncer current announce: 
							(RPackageRenamed 
									to: self 
									oldName: oldName 
									newName: aSymbol) ]! !

!RPackage methodsFor: 'accessing' stamp: 'DamienPollet 10/1/2010 11:52'!
organizer
	^ self class organizer! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:34'!
overriddenMethods
	^ Array streamContents: [:stream |
		self overriddenMethodsDo: [:each | stream nextPut: each]]
! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:34'!
overriddenMethodsDo: aBlock
	"Enumerates the methods the receiver contains which have been overridden by other packages"
	^ self allOverriddenMethodsDo: [:ea |
		(self isOverrideOfYourMethod: ea)
			ifTrue: [aBlock value: ea]]! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:35'!
overriddenMethodsInClass: aClass do: aBlock
	"Evaluates aBlock with the overridden methods in aClass"
	^ self overrideCategoriesForClass: aClass do: [:cat |
		self methodsInCategory: cat ofClass: aClass do: aBlock]! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:35'!
overrideCategoriesForClass: aClass do: aBlock
	"Evaluates aBlock with all the *foo-override categories in aClass"
	^ aClass organization categories do: [:cat |
		(self isOverrideCategory: cat) ifTrue: [aBlock value: cat]]! !

!RPackage methodsFor: 'accessing' stamp: 'cyrilledelaunay 5/13/2011 13:23'!
packageName

	^ name! !

!RPackage methodsFor: 'printing' stamp: 'StephaneDucasse 5/9/2011 17:03'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	aStream nextPutAll: self name.
	aStream nextPut: $)! !

!RPackage methodsFor: 'system compatibility' stamp: 'GuillermoPolito 5/1/2012 12:25'!
referenceForMethod: aSymbol ofClass: aClass
	^ (aClass >> aSymbol) asRingDefinition! !

!RPackage methodsFor: 'private-register' stamp: 'StephaneDucasse 4/22/2011 23:25'!
registerClass: aClass
	"Private method that declares the mapping between a class and its package."
	self organizer
		registerPackage: self forClass: aClass
	! !

!RPackage methodsFor: 'private-register' stamp: 'StephaneDucasse 4/22/2011 23:25'!
registerClassName: aClassNameSymbol
	"Private method that declares the mapping between a class and its package."
	self organizer
		registerPackage: self forClassName: aClassNameSymbol
	! !

!RPackage methodsFor: 'private-register' stamp: 'StephaneDucasse 5/26/2012 17:06'!
removeAllMethodsFromClassNamed: aClassNameSymbol
	"Remove all the methods (defined and extensions) that are related to class aClassNameSymbol. aClassNameSymbol is the name of a class and not a metaclass - see class comment."

	classDefinedSelectors removeKey: aClassNameSymbol ifAbsent: [nil].
	classExtensionSelectors removeKey: aClassNameSymbol ifAbsent: [nil].
	metaclassDefinedSelectors removeKey: aClassNameSymbol ifAbsent: [nil].
	metaclassExtensionSelectors removeKey: aClassNameSymbol ifAbsent: [nil].! !

!RPackage methodsFor: 'accessing' stamp: 'cyrilledelaunay 5/4/2011 15:56'!
removeClass: aClass
	"Remove the class and all its methods from the receiver"

	"This is the line you should uncomment if you want to debug the strange problem with the test: RPackageMCSynchronisationTest>>testRecategorizeClassUnregisterTheClassMethodsFromTheOldPackage. 
	The problem came from that at this point, two methods from the class were equals (whereas they should not). For now I just modified definedMethodsForClass:  to return an OrderedCollection instead of a Set, To be sure I don't forget any method to remove"
	
	"self haltIf: [(aClass methodDict at: #method1) = (aClass methodDict at: #method2)]."
	(self definedMethodsForClass: aClass instanceSide) do: [ :aCompiledMethod |
		"(self removeDefinedMethod: aCompiledMethod forClass: aClass instanceSide)."
		self removeMethod: aCompiledMethod 
		].
	"we also have also have to remove methods from class side"
	(self definedMethodsForClass: aClass classSide) do: [ :aCompiledMethod |
		"(self removeDefinedMethod: aCompiledMethod forClass: aClass classSide)."
		self removeMethod: aCompiledMethod 
		].
	self removeClassDefinitionWithoutCheckingMethods: aClass.! !

!RPackage methodsFor: 'class addition' stamp: 'StephaneDucasse 4/13/2011 21:57'!
removeClassDefinition: aClass
	"Remove the class definition from the package but not its methods."
	
	| removed aClassName|
	aClassName := aClass theNonMetaClass name.
	removed := classes remove: aClassName ifAbsent: [nil].
	removed ifNotNil: [
			self definedMethodsShouldBecomeExtensionWhenRemovingClass: aClassName.
			self unregisterClass: aClass.] 
	! !

!RPackage methodsFor: 'class tags' stamp: 'StephaneDucasse 7/25/2011 22:11'!
removeClassDefinition: aClass fromClassTag: aSymbol
	"Detags the class aClass with the tag aSymbol"
	
	self removeClassDefinitionName: aClass name fromClassTag: aSymbol! !

!RPackage methodsFor: 'class addition' stamp: 'sd 4/25/2010 15:46'!
removeClassDefinitionName: aClassName
	"remove the class definition from the package but not its method"
	
	| removed aClassNameSymbol |
	('* class' match: aClassName) ifTrue: [^ self error: 'no metaclass name'].
	aClassNameSymbol := aClassName asSymbol.
	removed := classes remove: aClassNameSymbol ifAbsent: [nil].
	removed ifNotNil: [
				self definedMethodsShouldBecomeExtensionWhenRemovingClass: aClassName.
				self unregisterClassName: aClassNameSymbol.] 
	! !

!RPackage methodsFor: 'class tags' stamp: 'StephaneDucasse 7/26/2011 00:15'!
removeClassDefinitionName: aClassName fromClassTag: aSymbol
	"Detags the class aClass with the tag aSymbol"
	
	| res |
	res :=  classTags at: aSymbol ifAbsent: [^ self].
	res remove: aClassName ifAbsent: nil.
	! !

!RPackage methodsFor: 'private-register' stamp: 'StephaneDucasse 5/26/2012 16:53'!
removeClassDefinitionNamed: aClassNameSymbol
	"aClassNameSymbol should be the name of a class and not a metaclass to be coherent with the class invariant that classes are only class names and not metaclass ones. 
	
	This method removes the class definition from the receiver and its organizer"

	| removed |
	removed := classes remove: aClassNameSymbol ifAbsent: [nil].
	removed ifNotNil: [ self unregisterClassName: aClassNameSymbol.] 
	! !

!RPackage methodsFor: 'accessing' stamp: 'cyrilledelaunay 1/5/2011 13:05'!
removeClassDefinitionWithoutCheckingMethods: aClass
	"Same than 'removeClassDefinition', excepts that it does not make any check to set defined methods as extensions"
	
	| removed aClassName|
	aClassName := aClass theNonMetaClass name.
	removed := classes remove: aClassName ifAbsent: [nil].
	removed ifNotNil: [
			self unregisterClass: aClass.] 
	! !

!RPackage methodsFor: 'class tags' stamp: 'StephaneDucasse 7/26/2011 00:10'!
removeClassTag: aSymbol
	"Remove the class tag from the receiver."
	
	classTags removeKey: aSymbol ifAbsent: [nil].! !

!RPackage methodsFor: 'accessing' stamp: 'cyrilledelaunay 5/4/2011 16:02'!
removeDefinedMethod: aCompiledMethod forClass: aClass 
	"Remove the method to the receiver as a defined method."
	
	self flag: #cyrille. "no need for this method since we have removeMethod and normally 
	given a compiledMethod and a package we know if it is extending or not the package."
	"CD: Indeed, I changed the code where this method was called (removeClass:) , and it does not raise more errors when running the tests.There is no longer senders of this method"
	aClass isMeta
		ifTrue: [(metaclassDefinedSelectors 
			at: aClass theNonMetaClass name  
			ifAbsent: [^nil]) remove: aCompiledMethod selector]
		ifFalse: [(classDefinedSelectors 
			at: aClass name 
			ifAbsent: [^nil]) remove: aCompiledMethod selector].	
	^ aCompiledMethod.! !

!RPackage methodsFor: 'compiled method handling' stamp: 'GuillermoPolito 5/29/2012 14:20'!
removeMethod: aCompiledMethod 
	"Remove the method to the receiver as a defined method."

	| mr mthClass |
	mthClass := aCompiledMethod methodClass. 
	mthClass isMeta
		ifTrue: [
			self removeSelector: aCompiledMethod selector ofMetaclassName: mthClass theNonMetaClass originalName.
		]
		ifFalse: [
			self removeSelector: aCompiledMethod selector ofClassName: mthClass originalName.
		].
	^ aCompiledMethod.! !

!RPackage methodsFor: 'selector handling' stamp: 'GuillermoPolito 5/29/2012 14:12'!
removeSelector: aSelector ofClassName: aClassName
	"Remove the method in the package but does not propagate to the class itself.  Note that this method does not remove the method from the class, it just records in the package that the method is not in the package anymore."
	
	self basicRemoveSelector: aSelector ofClassName: aClassName.
	(classExtensionSelectors at: aClassName ifAbsent: [ #() ]) ifEmpty: [
		classExtensionSelectors removeKey: aClassName ifAbsent: [].
	].
	(classDefinedSelectors at: aClassName ifAbsent: [ #() ]) ifEmpty: [
		classDefinedSelectors removeKey: aClassName ifAbsent: [].
	].

	((metaclassExtensionSelectors at: aClassName ifAbsent: [#()]) isEmpty and: [(classExtensionSelectors at: aClassName ifAbsent: [#()]) isEmpty])
		ifTrue: [
				self organizer unregisterExtendingPackage: self forClassName: aClassName
	]! !

!RPackage methodsFor: 'selector handling' stamp: 'GuillermoPolito 5/29/2012 14:12'!
removeSelector: aSelector ofMetaclassName: aClassName
	"Remove the method in the package. Note that this method does not remove the method from the class, it just records in the package that the method is not in the package anymore. aClassName is the sole instance class name and not its metaclass one: i.e. adding Point class>>new is done as removeSelector: #new ofMetaclassName: #Point"
	
	self basicRemoveSelector: aSelector ofMetaclassName: aClassName.
	(metaclassExtensionSelectors at: aClassName ifAbsent: [ #() ]) ifEmpty: [
		metaclassExtensionSelectors removeKey: aClassName ifAbsent: [].
	].
	(metaclassDefinedSelectors at: aClassName ifAbsent: [ #() ]) ifEmpty: [
		metaclassDefinedSelectors removeKey: aClassName ifAbsent: [].
	].

	((metaclassExtensionSelectors at: aClassName ifAbsent: [#()]) isEmpty and: [(classExtensionSelectors at: aClassName ifAbsent: [#()]) isEmpty])
		ifTrue: [
				self organizer unregisterExtendingPackage: self forClassName: aClassName
	]! !

!RPackage methodsFor: 'private' stamp: 'cyrilledelaunay 5/30/2011 16:22'!
reportBogusBehaviorOf: aSelector

	self logCr: 'RPackage log: Something wrong around ', aSelector asString , 'since the removeKey: is called on not present information.'.! !

!RPackage methodsFor: 'all accessing' stamp: 'sd 4/21/2010 16:12'!
selectors

	| sel |
	sel := Set new.
	metaclassExtensionSelectors valuesDo: [:each | sel addAll: each].
	classExtensionSelectors valuesDo: [:each | sel addAll: each].
	metaclassDefinedSelectors valuesDo: [:each | sel addAll: each].
	classDefinedSelectors valuesDo: [:each | sel addAll: each].
	^ sel
	! !

!RPackage methodsFor: 'accessing' stamp: 'DamienPollet 9/28/2010 17:11'!
selectorsForClass: aClass
	"Returns all selectors for a class in the receiver without distinction of extensions or not"
	
	^ (self includesClass: aClass)
		ifFalse: [self extensionSelectorsForClass: aClass]
		ifTrue: [self definedSelectorsForClass: aClass]
	! !

!RPackage methodsFor: 'system compatibility' stamp: 'cyrilledelaunay 2/4/2011 14:12'!
systemCategories

	"(RPackageOrganizer default packageNamed: 'HelpSystem-Core' asSymbol) systemCategories"
	"(PackageInfo named: 'HelpSystem-Core' asSymbol) systemCategories"
	^ self systemOrganization categories select: [:cat | self includesSystemCategory: cat]! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:35'!
systemCategoryPrefix
	^ self name! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:35'!
systemOrganization 

	^ Smalltalk globals organization! !

!RPackage methodsFor: 'system compatibility' stamp: 'StephaneDucasse 6/3/2012 23:30'!
systemSubPackages

	"return all RPackages matching with systemCategories of this RPackage"
	|tmpPackages|
	tmpPackages := OrderedCollection new.
	self systemCategories do: [:aString |
		(aString asSymbol = self name) ifFalse: [
			|tmpPackage|
			"Maybe a RPackage matching the subcategory name does not yet exist in the organizer (Because packageInfo lazily register category from system). In this case, We should also lazily register a new RPackage with the right contents inside:"
			tmpPackage := self organizer packageNamed: aString asSymbol ifAbsent: [self organizer default importFromPackageInfo: (PackageInfo named: aString)].
			tmpPackages add: (tmpPackage).
			].
		].
	^ tmpPackages! !

!RPackage methodsFor: 'class tags' stamp: 'StephaneDucasse 7/25/2011 22:28'!
tags
	"Returns the tags of the receiver"
	
	^ classTags keys! !

!RPackage methodsFor: 'private-register' stamp: 'StephaneDucasse 4/22/2011 23:25'!
unregisterClass: aClass
	"Private method that declares the mapping between a class and its package."
	self organizer
		unregisterPackage: self forClass: aClass.! !

!RPackage methodsFor: 'private-register' stamp: 'StephaneDucasse 4/22/2011 23:26'!
unregisterClassName: aClassNameSymbol
	"Private method that declares the mapping between a class and its package."
	self organizer unregisterPackage: self forClassName: aClassNameSymbol! !

!RPackage methodsFor: 'updating' stamp: 'EstebanLorenzano 7/27/2012 19:40'!
updateDefinedClassNamed: oldString withNewName: newString
	"this method should only be used with class names , and not metaclass names"
	(oldString substrings size > 1 or: [newString substrings size > 1]) ifTrue: [
		Error signal: 'You should not use metaclass names'
		].
	
	"=> update the 'classDefinedSelectors' dictionary (replace the old key by the new one)
       => update the 'metaclassDefinedSelectors' dictionary (replace the old key by the new one)"
	classes remove: oldString.
	classes add: newString.
	self flag: #cyrille. "what happens if this is a metaclass: it breaks the invariant of the package"
	"worse so far the second block below breaks"
	"the name of the method should be updateDefinedClassNamed: withNewName:"
	"CD: i only use this method when a class is renamed in the system (systemClassRenamedActionFrom:). Normally we are not able to rename a metaclass in the system (?) so we should never end up in a case with metaclass names ?  "
	
	(classDefinedSelectors at: oldString ifAbsent: [nil]) ifNotNil: [
		classDefinedSelectors at: newString put: (classDefinedSelectors at: oldString).
		classDefinedSelectors removeKey: oldString  ifAbsent: [self reportBogusBehaviorOf: #updateDefinedClassNamed:withNewName:   ]
		].
	
	(metaclassDefinedSelectors at: oldString ifAbsent: [nil]) ifNotNil: [
		metaclassDefinedSelectors at: newString put: (metaclassDefinedSelectors at: oldString).
		metaclassDefinedSelectors removeKey: oldString  ifAbsent: [self reportBogusBehaviorOf: #updateDefinedClassNamed:withNewName:   ]
		].! !

!RPackage methodsFor: 'updating' stamp: 'StephaneDucasse 4/13/2011 22:02'!
updateDefinedSelector: oldSelector inClass: aClass withNewSelector: newSelector

	aClass isMeta
		ifTrue: [
			(metaclassDefinedSelectors at: aClass instanceSide name asSymbol) remove: oldSelector. 
			(metaclassDefinedSelectors at: aClass instanceSide name asSymbol) add: newSelector. ]
		ifFalse: [
			(classDefinedSelectors  at: aClass name asSymbol) remove: oldSelector. 
			(classDefinedSelectors  at: aClass name asSymbol) add: newSelector. ]! !

!RPackage methodsFor: 'updating' stamp: 'StephaneDucasse 4/25/2011 12:29'!
updateExtensionForClassNamed: oldString withNewName: newString

	"=> update the 'classExtensionsSelectors' dictionary (replace the old key by the new one)
        => update the 'metaclassclassExtensionsSelectors' dictionary (replace the old key by the new one)"
	"classes remove: oldString.
	classes add: newString."
	
	(metaclassExtensionSelectors at: oldString ifAbsent: [nil]) ifNotNil: [
		metaclassExtensionSelectors at: newString put: (metaclassExtensionSelectors at: oldString).
		metaclassExtensionSelectors removeKey: oldString  ifAbsent: [self reportBogusBehaviorOf: #updateExtensionForClassNamed:withNewName:   ]
		].
	
	(classExtensionSelectors at: oldString ifAbsent: [nil]) ifNotNil: [
		classExtensionSelectors at: newString put: (classExtensionSelectors at: oldString).
		classExtensionSelectors removeKey: oldString ifAbsent: [self reportBogusBehaviorOf: #updateExtensionForClassNamed:withNewName:   ]
		].! !

!RPackage methodsFor: 'updating' stamp: 'cyrille.delaunay 11/16/2010 14:41'!
updateExtensionSelector: oldSelector inClass: aClass withNewSelector: newSelector

	aClass isMeta
		ifTrue: [
			(metaclassExtensionSelectors at: aClass instanceSide name asSymbol) remove: oldSelector. 
			(metaclassExtensionSelectors at: aClass instanceSide name asSymbol) add: newSelector. 
			]
		ifFalse: [
			(classExtensionSelectors  at: aClass name asSymbol) remove: oldSelector. 
			(classExtensionSelectors  at: aClass name asSymbol) add: newSelector. 
			]! !

!RPackage methodsFor: 'updating' stamp: 'cyrille.delaunay 11/16/2010 15:08'!
updateSelector: oldSelector inClass: aClass withNewSelector: newSelector

	"here we check if the old seletor is defined in the package or if it is an extension. Then we dispatch the work to the corresponding method.
	For one specific class, a selector is either a defined selector or an extension selector, there is no way to have a couple of class->selector present in both dictionary"
	
	(self includesDefinedSelector: oldSelector ofClass: aClass) 
		ifTrue: [^ self updateDefinedSelector: oldSelector inClass: aClass  withNewSelector: newSelector].
	(self includesExtensionSelector: oldSelector ofClass: aClass)
		ifTrue: [^ self updateExtensionSelector: oldSelector inClass: aClass  withNewSelector: newSelector].
		
		! !

Object subclass: #RPackageBenchmark
	instanceVariableNames: ''
	classVariableNames: 'OrganizerToBenchmark'
	poolDictionaries: ''
	category: 'RPackage-Core'!

!RPackageBenchmark commentStamp: '<historical>' prior: 0!
A dummy class to run some benchmarcks!

!RPackageBenchmark class methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 7/16/2010 15:58'!
organizerToBenchmark
	"self organizerToBenchmark"
	OrganizerToBenchmark 
		ifNil: [ OrganizerToBenchmark := RPackageOrganizer new initializeFromSystem].
	^ OrganizerToBenchmark! !

!RPackageBenchmark class methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 7/16/2010 15:53'!
resetOrganizerToBenchmark

	OrganizerToBenchmark := nil! !

!RPackageBenchmark class methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 7/29/2010 23:00'!
runForLog
	"To run the benchmark you may have to reset the organizer
	self resetOrganizerToBenchmark"	
	" self runForLog  "
	
	
	"17 July 2010
		class package access: 10
		extending package access: 13
		selector for class: 39
		extending package access +: 19
		method package access: 1173
	"
	

	
	| classes |
	RPackage 
		withOrganizer: self organizerToBenchmark
		do: [ :anOrganizer | 
			classes := Object withAllSubclasses.
			classes remove: UndefinedObject.
			classes remove: ClassTrait.
			classes remove: ClassTrait class.
			classes := classes reject: [:each | #('BogusInfo*' 'GRPackage*' 'MC*') 
												anySatisfy: [:pat | pat match: each name]].
			classes := classes reject: [:each | each package isNil].
			
			^ String streamContents: [:st |
					
					st nextPutAll: 'class package access: ',	(Time millisecondsToRun: [classes do: [:each | each package]]) printString ;cr.
					st nextPutAll: 'extending package access: ',	(Time millisecondsToRun: [classes do: [:each | each extendingPackages]]) printString ;cr.
		     			st nextPutAll: 'selector for class: ',	(Time millisecondsToRun: [classes do: [:each | each package selectorsForClass: each]]) printString ;cr.
					st nextPutAll: 'extending package access +: ',	(Time millisecondsToRun: 
																	[classes do: [:each | each extendingPackages 
																							do: [ :package | 
																								package selectorsForClass: each]]]) printString ;cr.
					st nextPutAll: 'method package access: ',	(Time millisecondsToRun: 
																	[classes do: [:each | each methods do: [:method | 
																				method packageFromOrganizer: anOrganizer ]]]) printString ;cr.
			
			
			
			]].
					
	
	! !

Object subclass: #RPackageOrganizer
	instanceVariableNames: 'classPackageMapping packages classExtendingPackagesMapping debuggingName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Core'!

RPackageOrganizer class
	instanceVariableNames: 'default'!

!RPackageOrganizer commentStamp: '<historical>' prior: 0!
A RPackageOrganizer is responsible for providing all the package currently defined in the system.
In addition it provides a back pointer from the class to its package.

The classPackageMapping and the classExtendingPackageMapping should be moved in the future to the classes themselves. 


For tests or actions that could destroy the package organizer,  do not access directly the singleton of RPackageOrganizer.
Use instead 
		RPackage withOrganizer: aNewOrganizer do: ablock
			or via RPackage organizer
		
	
RPackageOrganizer fillUp will fill up the system from the current PackageOrganizer
	"self fillUp"
	
-----------------------------------------------------------------------------------------------------------------------------------------------	
	
	
A rpackageOrganizer update itself when some changes are made in the system. It does that by registering to a systemAnnoucer, specifying an action when an annoucement is triggered.
Here is what I (Cyrille Delaunay) propose to do for each annocuement triggered:

SystemCategoryAddedAnnouncement 	
	=> I would just register a new RPackage (if it does not already exist) in the RPackageOrganizer
	
SystemCategoryRemovedAnnouncement 
     => I would just unregister the RPackage concerned from the organizer

SystemCategoryRenamedAnnouncement
     => I would update the RPackage concerned, by changing its name
     => I would update the 'packages' dictionary of the organizer, putting the new name as key

SystemClassAddedAnnouncement 
    => Import the class in the RPackage concerned (RPackage >> importClass:)
    => Register the class in the 'classPackageMapping' dictionary of the organizer (RPackageOrganizer >> registerPackage:forClass)
    (=> maybe we should pay attention if both the class and the metaclass launch this kind of event ?)

SystemClassRecategorizedAnnouncement
    => I would update the old RPackage concerned:
            => unregister the class
            => unregister all defined methods of the class
    => I would update the new RPackage:
            => Import the class in the RPackage (importClass:)
    => I would update the organizer:
            => update the 'classPackageDictionary' to point on the new RPackage

 
SystemClassRemovedAnnouncement
    => I would update the RPackake concerned
             => unregister the class
             => unregister all defined methods of the class
    => I would update the organizer:
             => update the 'classPackageDictionary' to remove the class

SystemClassRenamedAnnouncement
    => I would update the RPackage in which the class is defined:
             => update the 'classDefinedSelectors' dictionary (replace the old key by the new one)
             => update the 'metaclassDefinedSelectors' dictionary (replace the old key by the new one)
    => I would update all RPackages extending this class
             => update the 'classExtensionsSelectors' dictionary (replace the old key by the new one)
             => update the 'metaclassclassExtensionsSelectors' dictionary (replace the old key by the new one)
    => I would update the organizer
             => update the 'classPackageDictionary' to replace the key with the new class name
             => update the 'classExtendingPackagesMapping' to replace the key with the new class name
                          
SystemClassReorganizedAnnouncement 
    (=> I guess we should check if extensions have not been added or removed ? 
      (to retrieve this information, the only thing I found is ClassDescription >> organization, and then check each category begining with '*' and compare with the organizer. seems to be painful, no?))
	=> when an extension is removed, all methods inside are removed. Therefore, the MethodRemovedAnnounecement will do the job. Not sur this one still usefull

SystemProtocolAddedAnnouncement
    => I don't see anything to do for this annoucement

SystemProtocolRemovedAnnoucement
    => If the category is an extension from a package, I would move all the methods concerned, from the extending RPackage to the class RPackage

SystemMethodAddedAnnouncement
       => I would check the category in which the method has been defined
               => if it correspond to an extending package -> add the method to the extending RPackage
               => if not, add the method to the class parentPackage

SystemMethodModifiedAnnouncement
       this annoucement can correspond to several kind of modifications:
	       *  a method has been renamed
                       => I would update the rPackage in which the method is defined to replace the old selector by the new one
		* a method has been move to another category 
			-maybe from a classic category to an extending package
                             => we should move the method from the  method class parentPackage to extendingPackage package
			-maybe from an extending package to another extending package
                             => we should move the method from the  extendingPackage package to the other extendingPackage package
			-maybe from an extending package to a classic category
                             =>  we should move the method from the  extendingPackage to the method class parentPackage
		        -maybe from a classic category to another classic category
                             => we have nothing to do
			

SystemMethodRecategorizedAnnouncement
          same thing than above

SystemMethodRemovedAnnouncement
       => I would simply remove the method from the RPackage in which it is register!

RPackageOrganizer class
	instanceVariableNames: 'default'!

!RPackageOrganizer class methodsFor: 'utils' stamp: 'StephaneDucasse 6/2/2012 19:39'!
allManagers

	^ MCWorkingCopy allManagers! !

!RPackageOrganizer class methodsFor: 'utils' stamp: 'cyrille.delaunay 11/3/2010 18:26'!
computeDiffWithMC
	"self computerDiffWithMC"
	
	^ self rpackageNames difference: self packageInfoNames ! !

!RPackageOrganizer class methodsFor: 'singleton' stamp: 'TudorGirba 11/25/2010 23:51'!
default
	
	default isNil ifTrue: [
		default := self new.
		default ].
	^ default! !

!RPackageOrganizer class methodsFor: 'singleton' stamp: 'cyrilledelaunay 2/9/2011 11:15'!
fillUp
	"self fillUp"
	self default initializeFromSystemStartingFromPackageOrganizer.
	"initializing from system might have generated some new packageInfo (because Package Inof lazily register system categories). Therefore, we should iterate a second time over all package infos:"
	self default initializeFromSystemStartingFromPackageOrganizer.
	"We register to system announcement here (and not from the instance side), because we don't want that to be dome each time we create a PackageOrganizer. Only  an updated Organizer (that means that it is synchronized with all current packages of the system (doen throught 'initializeFromSystem')) should register. If it is not the case, it could generate big problems for your image"
	self default register. ! !

!RPackageOrganizer class methodsFor: 'class initialization' stamp: 'cyrilledelaunay 1/28/2011 15:58'!
initialize

	super initialize.
	self initializeDefault.! !

!RPackageOrganizer class methodsFor: 'initialize-release' stamp: 'cyrilledelaunay 1/28/2011 15:58'!
initializeDefault

	"self initializeDefault"
	self fillUp.! !

!RPackageOrganizer class methodsFor: 'private' stamp: 'StephaneDucasse 6/3/2012 22:39'!
packageClass

	^ RPackage! !

!RPackageOrganizer class methodsFor: 'utils' stamp: 'StephaneDucasse 6/2/2012 19:38'!
packageInfoNames
	"self packageInfoNames"
	
	^ self allManagers collect: [:each | each package name]
	
	! !

!RPackageOrganizer class methodsFor: 'initialize-release' stamp: 'StephaneDucasse 6/3/2012 22:40'!
removeMockPackagesFromOldOrganizer

	"the next line is a bit 'hacky'. It will remove the mock packages used by monticello test in packageInfo-Organizer. Those packages will now be subclasses of RPackage and should no longer be present in the packageInfo-organizer"
	|mockPackages|
	"mockPackages := PackageOrganizer default packages select: [:info | ((((info packageName = 'MCDirtyPackage') or: [info packageName = 'MCEmptyPackage']) or: [info packageName = 'MonticelloMocks']) 	or: [info isKindOf:  MCDirtyPackageInfo])]."
	mockPackages := self default packages select: [:info | (({'MCDirtyPackageInfo'. 'MCEmptyPackage'. 'MonticelloMocks'} includes: info packageName) 	or: [info isKindOf:  MCDirtyPackageInfo])].
	mockPackages do: [:each |
		self default unregisterPackage: each.
	].
	self default packagesDictionary removeKey: #'Monticello-Mocks' ifAbsent: [].! !

!RPackageOrganizer class methodsFor: 'singleton' stamp: 'StephaneDucasse 6/3/2012 22:39'!
resetDefault

	"self resetDefault"
	default  ifNotNil: [
		"When an Organizer is not used anymore, we should always pay attention that these two actions are corretly done."
		default unregisterInterestToSystemAnnouncement.
		MCWorkingCopy removeDependent: default].
	default := self new.
	self packageClass initialize! !

!RPackageOrganizer class methodsFor: 'utils' stamp: 'cyrille.delaunay 11/3/2010 18:24'!
rpackageNames
	"self computeDiffWithMC"
	
	^ default packages collect: [:each | each name]
	
	! !

!RPackageOrganizer methodsFor: 'accessing' stamp: 'StephaneDucasse 6/2/2012 19:39'!
allManagers

	^ self class allManagers ! !

!RPackageOrganizer methodsFor: 'private registration' stamp: 'cyrilledelaunay 5/30/2011 17:34'!
basicRegisterPackage: aPackage
	"A new package is now available and declared in the receiver. Note that it is a low level implementation method since it does not deal with package contained information and does not update the related mapping tables."
	
	packages at: aPackage name asSymbol put: aPackage.
	^ aPackage! !

!RPackageOrganizer methodsFor: 'private registration' stamp: 'cyrilledelaunay 5/30/2011 17:38'!
basicUnregisterPackage: aPackage
	"Unregister the specified package from the list of registered packages. Raise the announcement RPackageUnregistered. This is a low level action. It does not unregister the back pointer from classes to packages or any other information managed by the organizer"
	
	| symbol |
	symbol := aPackage name asSymbol.
	(self includesPackageNamed: symbol)
		ifTrue: [ packages removeKey: symbol ifAbsent: []]
		ifFalse: [self reportExtraRemovalOf: aPackage  ]
	! !

!RPackageOrganizer methodsFor: 'private registration' stamp: 'cyrilledelaunay 5/30/2011 17:38'!
basicUnregisterPackageNamed: aSymbolName
	"Unregister the specified package from the list of registered packages. Raise the RPackageUnregistered announcement. This is a low level action. It does not unregister the back pointer from classes to packages or any other information managed by the organizer"
	
	| symbol |
	symbol := aSymbolName asSymbol.
	(self includesPackageNamed: symbol) 
		ifTrue: [
			| aPackage | 
			aPackage := packages at: symbol. 
			packages removeKey: symbol ifAbsent: []].
	! !

!RPackageOrganizer methodsFor: 'mc synchronization tofix' stamp: 'cyrilledelaunay 2/1/2011 14:25'!
category: categoryName matches: prefix
	"self default category: 'Compression-Archives' matches: 'Compression'"
	"self default category: 'Compression' matches: 'Compression-Archives'"
	"self default category: 'Compression' matches: 'Compression'"
	"self default category: 'Compression-Arh' matches: 'Compression'"
	"self default category: 'CateGory' matches: 'category'"
	| prefixSize catSize |
	categoryName ifNil: [ ^false ].
	catSize := categoryName size.
	prefixSize := prefix size.
	catSize < prefixSize ifTrue: [ ^false ].
	(categoryName findString: prefix startingAt: 1 caseSensitive: false) = 1
		ifFalse: [ ^false ].
	^(categoryName at: prefix size + 1 ifAbsent: [ ^true ]) = $-! !

!RPackageOrganizer methodsFor: 'private' stamp: 'StephaneDucasse 4/24/2011 17:32'!
debuggingName

	^ debuggingName ! !

!RPackageOrganizer methodsFor: 'private' stamp: 'StephaneDucasse 4/24/2011 17:32'!
debuggingName: aString

	debuggingName := aString! !

!RPackageOrganizer methodsFor: 'initialize-release' stamp: 'StephaneDucasse 6/3/2012 22:42'!
defineUnpackagedClassesPackage
	^ self ensureExistAndRegisterPackageNamed: self packageClass defaultPackageName! !

!RPackageOrganizer methodsFor: 'public registration' stamp: 'StephaneDucasse 6/3/2012 22:55'!
ensureExistAndRegisterPackageNamed: aSymbol
	"A new package is now available and declared in the receiver."
	
	| aPackage |
	aPackage := packages at: aSymbol asSymbol ifAbsentPut: [self packageClass named: aSymbol].
	aPackage extendedClasses do: [ :extendedClass|
			self registerExtendingPackage: aPackage forClass: extendedClass].
	aPackage definedClasses do: [ :definedClass|
			self registerPackage: aPackage forClass: definedClass].
	self announcer announce: (RPackageCreated to: aPackage).
	^ aPackage! !

!RPackageOrganizer methodsFor: 'package access from class' stamp: 'sd 5/21/2010 14:56'!
extendingPackagesOf: aClass
	"Returns the packages extending the class aClass"
	^ classExtendingPackagesMapping at: aClass theNonMetaClass name ifAbsent: [#()]! !

!RPackageOrganizer methodsFor: 'package access from class' stamp: 'cyrille.delaunay 11/24/2010 14:24'!
extendingPackagesOfClassNamed: aName
	"Returns the packages extending the class named a Symbol"
	^ classExtendingPackagesMapping at: aName asSymbol ifAbsent: [#()]! !

!RPackageOrganizer methodsFor: 'package access from class' stamp: 'cyrilledelaunay 2/22/2011 13:54'!
globalPackageOf: aClass
	"this method should return the 'global' parent package of aClass, that means the package holding the (possible) subcategory in which aClass is concretely defined. For example, 'Object package' returns Kernel-Object, whereas 'PackageOrganizer packageOf: Object' returns Kernel. So I guess that all use of 'packageOf' should be replaced by this method  "

	"RPackageOrganizer default globalPackageOf: Object"

	| globalPackage classPackage |
	classPackage := self packageOf: aClass.
	globalPackage := self packages
		detect: [ :aRPackage | aRPackage ~= classPackage and: [ aRPackage systemCategories includes: classPackage name ] ]
		ifNone: [ ^ classPackage ].
	^ globalPackage! !

!RPackageOrganizer methodsFor: 'testing' stamp: 'IgorStasenko 8/12/2011 16:35'!
hasRegistered
	"return true if this package organizer has already registered interest to system events and Monticello changes "
	
	^ self announcer hasSubscriber: self
	
	"|actionSequence|
	self announcer subscriptions ifNil: [^ true].
	actionSequence := self announcer subscriptions values 
								detect: [:each | each anySatisfy: [:anAction | anAction receiver = RPackage organizer]] ifNone: [nil].
	self flag: #cyril.
	^ (actionSequence isNil not) and: [(MCWorkingCopy myDependents includes: self)]"! !

!RPackageOrganizer methodsFor: 'initialize-release' stamp: 'cyrilledelaunay 5/30/2011 17:30'!
importFromPackageInfo: info

	"PackageInfo lazy-initialize itself from all existing categories in the system. It can happen that we ask him for a non registered PackageInfo, and in this case it will just have to create a new PackageInfo with the right name. Then accessing the classes, methods is done throught the system interface, so no cache to update. It is not the same for RPackage. As rpackage initialize itself from package info, some categories can not been yet registered in RPackageOrganizer, which can be more problematic. For now we could create a packageInfo and import a new RPackage using the packageInfo interface (which is simplier than accessing categories then classes then methods, check what are extensions , ... )"
	|package|
	package := self ensureExistAndRegisterPackageNamed: info packageName.
			"My problem here: If a package appear here after one of its subcategories, all classes and methods would be re-affected to this package instead of the subcatagory. That's why I focus only on classes and methods that are not defined in subcategories, to avoid to override information set before"
			info classesNotDefinedInSubCategories  
				do: [ :each | package addClassDefinition: each ].
			info coreMethodsNotDefinedInSubCategories do: [ :each |
				"it seems that PackageInfo does not count methods from a trait inside the class package. We should do the same, as monticello expect this behavior"
				(each isValid and: [each isLocalSelector])
					ifTrue: [ package addMethod: each compiledMethod ] ].
			info extensionMethodsFromAllSystem  do: [ :each |
				"it seems that PackageInfo does not count methods from a trait inside the class package. We should do the same, as monticello expect this behavior"
				(each isValid and: [each isLocalSelector])
					ifTrue: [ package addMethod: each compiledMethod ]
					].
				
		^ package! !

!RPackageOrganizer methodsFor: 'deprecated' stamp: 'BenjaminVanRyseghem 4/17/2011 16:37'!
includesClass: aClass
	self deprecated: 'use includesPackageBackPointerForClass:'. 
	^ self includesPackageBackPointerForClass: aClass! !

!RPackageOrganizer methodsFor: 'deprecated' stamp: 'StephaneDucasse 4/13/2011 20:10'!
includesClassNamed: aSymbol
	self deprecated: 'Use includesPackageBackPointerForClassNamed: aSymbol'.
	
	^ self includesPackageBackPointerForClassNamed: aSymbol ! !

!RPackageOrganizer methodsFor: 'testing' stamp: 'StephaneDucasse 4/13/2011 20:14'!
includesPackage: aPackage
	"Answer whether the receiver get a package as registered."
	^ self includesPackageNamed: aPackage name! !

!RPackageOrganizer methodsFor: 'private testing' stamp: 'BenjaminVanRyseghem 4/17/2011 16:50'!
includesPackageBackPointerForClass: aClass

	^ classPackageMapping includesKey: aClass instanceSide name asSymbol! !

!RPackageOrganizer methodsFor: 'private testing' stamp: 'BenjaminVanRyseghem 4/17/2011 16:46'!
includesPackageBackPointerForClassNamed: aSymbol

	^ classPackageMapping includesKey: aSymbol asSymbol! !

!RPackageOrganizer methodsFor: 'testing' stamp: 'StephaneDucasse 4/13/2011 22:57'!
includesPackageNamed: aSymbol
	"Answer whether the receiver get a package named aSymbol as registered."
	^ packages includesKey:  aSymbol asSymbol! !

!RPackageOrganizer methodsFor: 'initialize-release' stamp: 'StephaneDucasse 4/24/2011 17:31'!
initialize
	super initialize.
	packages := IdentityDictionary new.
	classPackageMapping := IdentityDictionary new.
	classExtendingPackagesMapping := IdentityDictionary new.
	debuggingName := ''.
	self defineUnpackagedClassesPackage! !

!RPackageOrganizer methodsFor: 'initialize-release' stamp: 'StephaneDucasse 6/2/2012 19:45'!
initializeFromSystem
	""
	| package |
	self allManagers 
		do: [ :workingCopy |
			| info |
			info := workingCopy packageInfo.
			package := self ensureExistAndRegisterPackageNamed: info packageName.
			"My problem here: If a package appear here after one of its subcategories, all classes and methods would be re-affected to this package instead of the subcatagory. That's why I focus only on classes and methods that are not defined in subcategories, to avoid to override information set before"
			info classesNotDefinedInSubCategories  
				do: [ :each | package addClassDefinition: each ].
			info coreMethodsNotDefinedInSubCategories do: [ :each |
				each isValid
					ifTrue: [ package addMethod: each compiledMethod ] ].
			info extensionMethods  do: [ :each |
				each isValid
					ifTrue: [ package addMethod: each compiledMethod ] ] ]
		displayingProgress: 'Importing from MC managers'
	"strange PackageOrganizer default packages size is not equal to MCWorkingCopy allManagers size
	MCWorkingCopy allManagers size = PackageOrganizer default packages size.
	But MCWorkingCopy allManagers size is equal to RPackageOrganizer size (minus the defaylt package):
	MCWorkingCopy allManagers size = (RPackageOrganizer default packages reject: [:each | each name = '_DefaultPackage']) size.
	
	Let see what are the packages that are not registered in RPackage.
	PackageOrganizer default packages reject: [:each | RPackageOrganizer default includesPackageNamed: each packageName asSymbol].
	"
	
! !

!RPackageOrganizer methodsFor: 'initialize-release' stamp: 'cyrilledelaunay 5/30/2011 17:30'!
initializeFromSystemStartingFromPackageOrganizer
	"this method will do the same job than initializeFromSystem except that it will start from all packages in the package organizer, instead of the ones of Monticello. Even when starting from the workingCopies of monticello, we ask to the corresponding package info to retrrieve information. Moreover, monticello does not refer all packages in packageOrganizer (surely because of some sub-categories not yet taken into account)"
	| package |
	PackageOrganizer default packages copy
		do: [ :aPackageInfo |
			| info |
			info := aPackageInfo.
			"PackageOrganizer contains a quite special packageInfo used by monticello test. It is subclass of MCDirtyPackageInfo. Its instance variable is initialized as #'Monticello-Mocks' but MCDirtyPackageInfo>> packageName return another name. The tests expect to have #'Monticello-Mocks' as name: "
			info methodCategoryPrefix = '*mcdirtypackage' ifTrue: [
				self ensureExistAndRegisterPackageNamed:   #'Monticello-Mocks'
				].
			self importFromPackageInfo: info]
		displayingProgress: 'Importing from PackageOrganizer'
	"strange PackageOrganizer default packages size is not equal to MCWorkingCopy allManagers size
	MCWorkingCopy allManagers size = PackageOrganizer default packages size.
	But MCWorkingCopy allManagers size is equal to RPackageOrganizer size (minus the defaylt package):
	MCWorkingCopy allManagers size = (RPackageOrganizer default packages reject: [:each | each name = '_DefaultPackage']) size.
	
	Let see what are the packages that are not registered in RPackage.
	PackageOrganizer default packages reject: [:each | RPackageOrganizer default includesPackageNamed: each packageName asSymbol].
	"
	
	! !

!RPackageOrganizer methodsFor: 'mc synchronization tofix' stamp: 'StephaneDucasse 6/2/2012 19:37'!
isDefinedAsPackageOrSubPackageInMC: aSymbol
	"a category has been added. 
	#'AST-Core'
	Now the question is to know whether AST-Core already exists as a package.
	"
	"self default isDefinedAsPackageOrSubPackageInMC: #Compression"
	"self default isDefinedAsPackageOrSubPackageInMC: #'Compression-Archives'"
	"self default isDefinedAsPackageOrSubPackageInMC: #'Collections'"
	"self default isDefinedAsPackageOrSubPackageInMC: #'Collections-Unordered'"
	"self default isDefinedAsPackageOrSubPackageInMC: #'Collections-Unordered-Test'"
	^ self allManagers 
			anySatisfy: [:each | self category: each packageName asSymbol matches: aSymbol ] ! !

!RPackageOrganizer methodsFor: 'mc synchronization tofix' stamp: 'StephaneDucasse 6/2/2012 19:38'!
isDefinedPackageInMC: aSymbol
	"Answer whether a package is already defined with the exact name"
	"self default isDefinedAsSubPackageInMC: #Compression"
	"self default isDefinedAsSubPackageInMC: #'Compression-Archives'"
	^ self allManagers anySatisfy: [:each | each packageName asSymbol = aSymbol]! !

!RPackageOrganizer methodsFor: 'accessing' stamp: 'StephaneDucasse 6/3/2012 22:42'!
packageClass
	"Return the system class that represent packages."
	
	^ RPackage
	! !

!RPackageOrganizer methodsFor: 'accessing' stamp: 'tg 3/13/2010 16:39'!
packageDefiningOrExtendingMethod: aCompiledMethod
	^ self packageDefiningOrExtendingSelector: aCompiledMethod selector inClass: aCompiledMethod methodClass
! !

!RPackageOrganizer methodsFor: 'accessing' stamp: 'cyrilledelaunay 5/10/2011 12:26'!
packageDefiningOrExtendingSelector: aSelector inClass: aClass
	"this implementation is slower
		aClass packages detect: [:each | each includesSelector: aSelector ofClass: aClass ]"

	
	^ (aClass packages) detect: [:each | each includesSelector: aSelector ofClass: aClass ] ifNone: [
		"if we do not find in the packages of the class, it means that the method is coming from a trait: "
		|tmpTrait|
		tmpTrait := (aClass traitComposition traitProvidingSelector: aSelector).
		(aClass traitComposition traitProvidingSelector: aSelector) packages detect: [:each |
			each includesSelector: aSelector ofClass: tmpTrait.   
			].
		]
	
"	self packages detect: [:each | 
		each includesSelector: aSelector ofClass: aClass ].
"	
	! !

!RPackageOrganizer methodsFor: 'accessing' stamp: 'GuillermoPolito 5/29/2012 13:47'!
packageDefiningOrExtendingSelector: aSelector inClassNamed: aClassNameSymbol
	"this implementation is slower
		aClass packages detect: [:each | each includesSelector: aSelector ofClass: aClass ]"
	| classPackage |
	
	classPackage := self packageOfClassNamed: aClassNameSymbol.
	(classPackage includesSelector: aSelector ofClassName: aClassNameSymbol)
		ifTrue: [ ^classPackage ].
		
	^(self extendingPackagesOfClassNamed: aClassNameSymbol)
		detect: [ :p | p includesSelector: aSelector ofClassName: aClassNameSymbol ]
		ifNone: [ self error: ('No package found for selector {1} in class {2}' 
									format: { aSelector . aClassNameSymbol }) ]! !

!RPackageOrganizer methodsFor: 'accessing' stamp: 'GuillermoPolito 5/29/2012 14:00'!
packageDefiningOrExtendingSelector: aSelector inMetaclassNamed: aClassNameSymbol
	"this implementation is slower
		aClass packages detect: [:each | each includesSelector: aSelector ofClass: aClass ]"
	| classPackage |
	
	classPackage := self packageOfClassNamed: aClassNameSymbol.
	(classPackage includesSelector: aSelector ofMetaclassName: aClassNameSymbol)
		ifTrue: [ ^classPackage ].
		
	^(self extendingPackagesOfClassNamed: aClassNameSymbol)
		detect: [ :p | p includesSelector: aSelector ofMetaclassName: aClassNameSymbol ]
		ifNone: [ self error: ('No package found for selector {1} in class {2}' 
									format: { aSelector . aClassNameSymbol }) ]! !

!RPackageOrganizer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/17/2011 16:54'!
packageNamed: aSymbol

	^ packages at: aSymbol asSymbol! !

!RPackageOrganizer methodsFor: 'accessing' stamp: 'cyrilledelaunay 2/3/2011 17:27'!
packageNamed: aSymbol  ifAbsent: errorBlock

	^ packages at: aSymbol ifAbsent: errorBlock! !

!RPackageOrganizer methodsFor: 'accessing' stamp: 'stephane.ducasse 7/16/2009 23:17'!
packageNames
	^ packages keys! !

!RPackageOrganizer methodsFor: 'package access from class' stamp: 'StephaneDucasse 6/3/2012 22:42'!
packageOf: aClass

	^ classPackageMapping 
		at: aClass theNonMetaClass originalName
		ifAbsent: [self packageNamed: self packageClass defaultPackageName]! !

!RPackageOrganizer methodsFor: 'package access from class' stamp: 'StephaneDucasse 4/29/2011 21:04'!
packageOfClassNamed: aName

	self flag: self. "shouldProbablyReturnUnunpackagedPackage instead of nil"
	^ classPackageMapping at: aName asSymbol ifAbsent: [nil]! !

!RPackageOrganizer methodsFor: 'accessing' stamp: 'stephane.ducasse 7/10/2009 11:27'!
packages
	
	^ packages values! !

!RPackageOrganizer methodsFor: 'printing' stamp: 'StephaneDucasse 4/24/2011 17:33'!
printOn: aStream

	super printOn: aStream.
	debuggingName ifNotNil: [aStream nextPutAll: debuggingName ].  ! !

!RPackageOrganizer methodsFor: 'initialize-release' stamp: 'EstebanLorenzano 5/21/2012 17:50'!
register

	"self registerInterestToMC."
	self registerInterestToSystemAnnouncement.! !

!RPackageOrganizer methodsFor: 'private registration' stamp: 'sd 5/21/2010 14:44'!
registerExtendingPackage: aPackage forClass: aClass 

	| cur |
	cur := classExtendingPackagesMapping at: aClass theNonMetaClass name ifAbsent: [nil].
	cur isNil
		ifTrue: [classExtendingPackagesMapping at: aClass theNonMetaClass name put: (Set with: aPackage)]
		ifFalse: [cur add: aPackage]! !

!RPackageOrganizer methodsFor: 'private registration' stamp: 'cyrille.delaunay 11/24/2010 14:06'!
registerExtendingPackage: aPackage forClassName: aClassName 

	| cur |
	cur := classExtendingPackagesMapping at: aClassName asSymbol ifAbsent: [nil].
	cur isNil
		ifTrue: [classExtendingPackagesMapping at: aClassName asSymbol put: (Set with: aPackage)]
		ifFalse: [cur add: aPackage]! !

!RPackageOrganizer methodsFor: 'public registration' stamp: 'IgorStasenko 8/12/2011 16:36'!
registerPackage: aPackage
	"A new package is now available and declared in the receiver. "
	
	
	self basicRegisterPackage: aPackage.
	aPackage extendedClasses do: [ :extendedClass|
			self registerExtendingPackage: aPackage forClass: extendedClass].
	aPackage definedClasses do: [ :definedClass|
			self registerPackage: aPackage forClass: definedClass].
	self announcer announce: (RPackageCreated to: aPackage).
	^ aPackage! !

!RPackageOrganizer methodsFor: 'private registration' stamp: 'cyrille.delaunay 11/25/2010 15:08'!
registerPackage: aPackage forClass: aClass 
	(aPackage includesClass: aClass) 
		ifFalse: 
			[self error: aPackage name , ' does not includes the class ' , aClass name].
	^classPackageMapping at: aClass theNonMetaClass name put: aPackage! !

!RPackageOrganizer methodsFor: 'private registration' stamp: 'StephaneDucasse 4/13/2011 18:50'!
registerPackage: aPackage forClassName: aClassNameSymbol
	"Register aPackage as the package of the class aClassNameSymbol. The package should contain the class in its class definitions."
	
	(aPackage includesClassNamed: aClassNameSymbol asSymbol) 
		ifFalse: 
			[self error: aPackage name , ' does not include the class ' , aClassNameSymbol].
	^classPackageMapping at: aClassNameSymbol put: aPackage! !

!RPackageOrganizer methodsFor: 'renaming' stamp: 'MarianoMartinezPeck 6/16/2012 23:59'!
renamePackage: aPackage in: aString

	| classes oldPackageName |
	(packages includesKey: aString asSymbol)
		ifTrue: [ ^ self openAlreadyExistingError ].

	oldPackageName := aPackage name.
	classes := aPackage definedClasses.
	classes do: [:class |
		class category: aString ].	
	self unregisterPackage: aPackage.
	aPackage name: aString.
	self registerPackage: aPackage.
	aPackage extensionMethods do: [ :aMethod | 
		| aProtocol |
		aProtocol := aMethod methodClass organization categoryOfElement: aMethod selector.
		aMethod methodClass organization renameCategory: aProtocol asSymbol 
					toBe: (aProtocol copyReplaceAll: oldPackageName with: aString) asSymbol.
	].
	
	classes do: [:class |
		class category: aString ].
	
	^ aPackage! !

!RPackageOrganizer methodsFor: 'private' stamp: 'cyrilledelaunay 5/30/2011 16:22'!
reportBogusBehaviorOf: aSelector

	self logCr: 'RPackage log: Something wrong around ', aSelector asString , 'since the removeKey: is called on not present information.'.! !

!RPackageOrganizer methodsFor: 'private' stamp: 'cyrilledelaunay 5/30/2011 16:15'!
reportExtraRemovalOf: aClass

	self logCr:  'The class ',  aClass name printString, 'is removed twice'; cr.! !

!RPackageOrganizer methodsFor: 'mc synchronization tofix' stamp: 'StephaneDucasse 4/29/2011 20:59'!
shouldDefineAPackage: aSymbol
	"we should define a package if it is not created and it correspond to an MC package"
	"now this is not clear that we need that since an MC package is only created after creating a category"
	"Watch out!! Not tested"
	
	^ (self includesPackageNamed: aSymbol)
			ifTrue: [false]
			ifFalse: [ (self isDefinedPackageInMC: aSymbol) 
						ifTrue: [ true]
						ifFalse: [ (self isDefinedAsPackageOrSubPackageInMC: aSymbol)]]! !

!RPackageOrganizer methodsFor: 'private' stamp: 'CamilleTeruel 7/29/2012 18:47'!
stopNotification
	"(self instVarNamed: #default) stopNotification"
	
	"pay attention that we can break the system using this method"
	
	SystemAnnouncer uniqueInstance unsubscribe: self.
	MCWorkingCopy removeDependent: self.! !

!RPackageOrganizer methodsFor: 'initialize-release' stamp: 'EstebanLorenzano 5/21/2012 17:57'!
unregister
	SystemAnnouncer unsubscribe: self.! !

!RPackageOrganizer methodsFor: 'private registration' stamp: 'sd 5/19/2010 16:13'!
unregisterExtendingPackage: aPackage forClass: aClass
	
	| cur |
	cur := classExtendingPackagesMapping at: aClass theNonMetaClass name ifAbsent: [nil].
	cur isNil
		ifFalse: [cur remove: aPackage ifAbsent: [] "not happy with this one"]! !

!RPackageOrganizer methodsFor: 'private registration' stamp: 'cyrille.delaunay 11/24/2010 14:06'!
unregisterExtendingPackage: aPackage forClassName: aClassName
	
	| cur |
	cur := classExtendingPackagesMapping at: aClassName asSymbol ifAbsent: [nil].
	cur isNil
		ifFalse: [cur remove: aPackage ifAbsent: [] "not happy with this one"]! !

!RPackageOrganizer methodsFor: 'public registration' stamp: 'IgorStasenko 8/12/2011 16:36'!
unregisterPackage: aPackage
	"Unregister the specified package from the list of registered packages. Raise the announcement RPackageUnregistered."
	
	| symbol |
	self basicUnregisterPackage: aPackage.
	aPackage extendedClasses do: [ :extendedClass|
			self unregisterExtendingPackage: aPackage forClass: extendedClass].
	aPackage definedClasses do: [ :definedClass|
			self unregisterPackage: aPackage forClass: definedClass].
	self announcer announce: (RPackageCreated to: aPackage).
	^ aPackage! !

!RPackageOrganizer methodsFor: 'private registration' stamp: 'StephaneDucasse 4/18/2011 11:37'!
unregisterPackage: aPackage forClass: aClass 
	"unregister the back pointer mapping from classes to packages."
		
	^classPackageMapping 
			removeKey: aClass theNonMetaClass name 
			ifAbsent: [Transcript show: 'here' ; cr. 
						self reportExtraRemovalOf: aClass ]! !

!RPackageOrganizer methodsFor: 'private registration' stamp: 'StephaneDucasse 4/25/2011 12:30'!
unregisterPackage: aPackage forClassName: aClassName
	"Unregister the package back pointer for a given class. The class should not belong to the package anymore before removing the back pointer."

	(aPackage includesClassNamed: aClassName asSymbol) 
		ifTrue: 
			[self error: aPackage name , ' still includes the class ' , aClassName asSymbol].
	^classPackageMapping removeKey: aClassName asSymbol ifAbsent: [self reportBogusBehaviorOf: #unregisterPackage:forClassName:  ]! !

!RPackageOrganizer methodsFor: 'public registration' stamp: 'cyrilledelaunay 5/30/2011 17:38'!
unregisterPackageNamed: symbol
	"Unregister the specified package from the list of registered packages. Raise the announcement RPackageUnregistered."
	
	| aPackage |
	aPackage := packages at: symbol asSymbol ifAbsent: [ nil].
	aPackage 
		ifNotNil: [self unregisterPackage: aPackage].
	^ aPackage! !

!RPackageOrganizer methodsFor: 'mc synchronization tofix' stamp: 'cyrilledelaunay 5/30/2011 17:30'!
update: anArray
	"User create a new package, MCWorkingCopy propagates changes. We react accordingly."
	
	super update: anArray.
	(anArray isArray and: [ anArray first = #registered ])
		ifTrue: [ | newPackage |
			"we first look if a RPackage has not yet been registered (by creating a category in the system).
			 In this case we don't want to register a new RPackage, but refer to this existing category"
			(self packageExactlyMatchingExtensionName: anArray second name) isNil
				ifTrue: [
					"if no package already exist, we add a new one"
					newPackage := self ensureExistAndRegisterPackageNamed: anArray second name.
					"a rpackage is matching exactly a sytem category. So all classes should be registered to their parent category. 
					We should not import categories" ]		
			"Probably can get a bug since we can have a package named AST and the category named AST-Core so should probably 
	pass the category as parameter"].

	(anArray isArray and: [ anArray first = #unregistered ])
		ifTrue: [ 
			"Not sure if we should remove the corresponding RPackage from the organizer. Monticello will notify a #unregistered change when we 'delete' a working copy, or when we 'unload' a workingCopy. 'Delete'  will only delete the MCWorkingCopy representing the package, but will let the category and classes existing in the system. 'Unload' will also remove all classes inside the category but will also let the category. So, for now,  in both cases it seems meaningfull to keep a RPackage pointing to the existing category. At least Monticello tests were expecting this behavior"
			"self unregisterPackageNamed: anArray second name."
			self flag: #cyrille. "shouldDoSomethingHere."
			"SD: my impression is that we should redo part of the MC browser. Delete package may move the classes to unpackaged" 
			"CD: When you 'delete' a MCPackage, it only remove the MC working copy, but let all the included classes in the system (in the same category). So now the question is: should we keep those classes in the same RPackage or move them to the #_UnpackagedPackage. As those classes are not moved to any other category for now , we could keep them in the same RPackage. 
			In any case, if deleting a MCPackage would move the classes to 'Unclassified' category, some announcement should be emitted , and RPackage should update itself ?  "
			].! !

!RPackageOrganizer methodsFor: 'mc synchronization tofix' stamp: 'EstebanLorenzano 5/21/2012 18:08'!
updateAfterNewMCPackageRegistred: anAnnouncement
	"User create a new package, MCWorkingCopy propagates changes. We react accordingly."
	| newPackage name |
	
	name := anAnnouncement package name.
"super update: anArray."
			"we first look if a RPackage has not yet been registered (by creating a category in the system).
			 In this case we don't want to register a new RPackage, but refer to this existing category"
			(self packageExactlyMatchingExtensionName: name) isNil
				ifTrue: [
					"if no package already exist, we add a new one"
					newPackage := self ensureExistAndRegisterPackageNamed:  name.
					"a rpackage is matching exactly a sytem category. So all classes should be registered to their parent category. 
					We should not import categories" ]		
			"Probably can get a bug since we can have a package named AST and the category named AST-Core so should probably 
	pass the category as parameter"! !

!RPackageOrganizer methodsFor: 'mc synchronization tofix' stamp: 'EstebanLorenzano 5/21/2012 18:05'!
updateAfterNewMCPackageUnregistred: anAnnouncement

			"Not sure if we should remove the corresponding RPackage from the organizer. Monticello will notify a #unregistered change when we 'delete' a working copy, or when we 'unload' a workingCopy. 'Delete'  will only delete the MCWorkingCopy representing the package, but will let the category and classes existing in the system. 'Unload' will also remove all classes inside the category but will also let the category. So, for now,  in both cases it seems meaningfull to keep a RPackage pointing to the existing category. At least Monticello tests were expecting this behavior"
			"self unregisterPackageNamed: anArray second name."
			self flag: #cyrille. "shouldDoSomethingHere."
			"SD: my impression is that we should redo part of the MC browser. Delete package may move the classes to unpackaged" 
			"CD: When you 'delete' a MCPackage, it only remove the MC working copy, but let all the included classes in the system (in the same category). So now the question is: should we keep those classes in the same RPackage or move them to the #_UnpackagedPackage. As those classes are not moved to any other category for now , we could keep them in the same RPackage. 
			In any case, if deleting a MCPackage would move the classes to 'Unclassified' category, some announcement should be emitted , and RPackage should update itself ?  "! !

!ClassDescription methodsFor: '*rpackage-core' stamp: 'sd 10/29/2009 20:31'!
compileSilently: code 
	"Compile the code and classify the resulting method in the given category, leaving no trail in the system log, nor in any change set, nor in the 'recent submissions' list. This should only be used when you know for sure that the compilation will succeed."

	^ self compileSilently: code classified: 'not defined category' notifying: nil.! !

!ClassDescription methodsFor: '*rpackage-core' stamp: 'StephaneDucasse 6/3/2012 22:35'!
extendingPackages
	"the extending packages of a class are the packages that extend it."
	^ RPackage organizer extendingPackagesOf: self
	! !

!ClassDescription methodsFor: '*rpackage-core' stamp: 'StephaneDucasse 4/20/2010 22:10'!
isDefinedInPackage: aPackage
	"returns true if aPackage contains the definitino of this class"
	
	^ aPackage includesClass: self.
	! !

!ClassDescription methodsFor: '*rpackage-core' stamp: 'StephaneDucasse 5/15/2010 19:54'!
isExtended

	^ self extendingPackages isEmpty! !

!ClassDescription methodsFor: '*rpackage-core' stamp: 'tg 3/16/2010 17:53'!
isExtendedInPackage: aPackage
	"returns true if aPackage defines an extension to this class"
	^ aPackage extendsClass: self.
	! !

!ClassDescription methodsFor: '*rpackage-core' stamp: 'StephaneDucasse 6/3/2012 22:35'!
package
	^ RPackage organizer packageOf: self.	! !

!ClassDescription methodsFor: '*rpackage-core' stamp: 'tg 3/16/2010 17:36'!
packageFromOrganizer: anOrganizer
	"returns the package that defines this class"
	^ anOrganizer packageOf: self.
	! !

!ClassDescription methodsFor: '*rpackage-core' stamp: 'StephaneDucasse 6/3/2012 22:34'!
packageOrganizer
	"Returns the organizer of this class"
	^ RPackage organizer ! !

!ClassDescription methodsFor: '*rpackage-core' stamp: 'sd 5/19/2010 16:31'!
packages
	"the extending packages of a class are the packages that extend it."
	
	^  self extendingPackages asSet copy add: self package; yourself! !
RPackage initialize!
RPackageOrganizer initialize!
